=== modified file 'NEWS'
--- NEWS	2009-04-07 13:08:21 +0000
+++ NEWS	2009-04-07 13:56:43 +0000
@@ -117,6 +117,16 @@
   the ``long`` and ``short`` log formatters now tell the user
   how to see the hidden merged revisions.  (Ian Clatworthy)
 
+* The ``brisbane-core`` project has delivered its beta format
+  ``development6-rich-root``. This format is suitable for judicious
+  testing by early adopters. In particular if you are benchmarking bzr
+  performance please be sure to test using this format. At this stage
+  more information is best obtained by contacting the Bazaar mailing list
+  or IRC channel if you are interested in using this format. We will make
+  end user documentation available closer to blessing the format as
+  production ready. (Robert Collins, John Arbash Meinel, Ian Clatworthy,
+  Vincent Ladeuil, Andrew Bennetts, Martin Pool)
+
 * Tildes are no longer escaped. No more %7Euser/project/branch!
   (Jonathan Lange)
 

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2009-04-03 15:18:15 +0000
+++ bzrlib/bzrdir.py	2009-04-07 12:32:42 +0000
@@ -3423,9 +3423,9 @@
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat5',
     )
-# The following two formats should always just be aliases.
-format_registry.register_metadir('development',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment2',
+# The following un-numbered 'development' formats should always just be aliases.
+format_registry.register_metadir('development-rich-root',
+    'bzrlib.repofmt.groupcompress_repo.RepositoryFormatCHK1',
     help='Current development format. Can convert data to and from pack-0.92 '
         '(and anything compatible with pack-0.92) format repositories. '
         'Repositories and branches in this format can only be read by bzr.dev. '
@@ -3433,7 +3433,7 @@
         'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     experimental=True,
     alias=True,
     )
@@ -3446,55 +3446,26 @@
         'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     experimental=True,
-    alias=True,
+    alias=False, # Restore to being an alias when an actual development subtree format is added
+                 # This current non-alias status is simply because we did not introduce a
+                 # chk based subtree format.
     )
+
 # And the development formats above will have aliased one of the following:
-format_registry.register_metadir('development2',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment2',
-    help='1.6.1 with B+Tree based index. '
-        'Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
-        'before use.',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
-    experimental=True,
-    )
-format_registry.register_metadir('development2-subtree',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment2Subtree',
-    help='1.6.1-subtree with B+Tree based index. '
-        'Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
-        'before use.',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
-    experimental=True,
-    )
-# These next two formats should be removed when the gc formats are
-# updated to use WorkingTreeFormat6 and are merged into bzr.dev
-format_registry.register_metadir('development-wt6',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6',
-    help='1.14 with filtered views. '
-        'Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
-        'before use.',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat6',
-    hidden=True,
-    experimental=True,
-    )
-format_registry.register_metadir('development-wt6-rich-root',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6RichRoot',
-    help='A variant of development-wt6 that supports rich-root data '
-         '(needed for bzr-svn and bzr-git).',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat6',
-    hidden=True,
-    experimental=True,
-    )
+format_registry.register_metadir('development6-rich-root',
+    'bzrlib.repofmt.groupcompress_repo.RepositoryFormatCHK1',
+    help='pack-1.9 with 255-way hashed CHK inv, group compress, rich roots '
+        'Please read '
+        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
+        'before use.',
+    branch_format='bzrlib.branch.BzrBranchFormat7',
+    tree_format='bzrlib.workingtree.WorkingTreeFormat6',
+    hidden=True,
+    experimental=True,
+    )
+
 # The following format should be an alias for the rich root equivalent 
 # of the default format
 format_registry.register_metadir('default-rich-root',

=== modified file 'bzrlib/chk_serializer.py'
--- bzrlib/chk_serializer.py	2009-04-03 02:29:30 +0000
+++ bzrlib/chk_serializer.py	2009-04-07 12:32:42 +0000
@@ -63,8 +63,4 @@
         self.search_key_name = search_key_name
 
 
-chk_serializer_subtree_parent_id = CHKSerializerSubtree(4096, 'plain')
-chk_serializer_parent_id = CHKSerializer(4096, 'plain')
-chk_serializer_16_parent_id = CHKSerializer(4096, 'hash-16-way')
-chk_serializer_255_parent_id = CHKSerializer(4096, 'hash-255-way')
 chk_serializer_255_bigpage = CHKSerializer(65536, 'hash-255-way')

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2009-04-07 04:21:55 +0000
+++ bzrlib/inventory.py	2009-04-07 12:32:42 +0000
@@ -1182,14 +1182,6 @@
         return other
 
     def _get_mutable_inventory(self):
-        """Returns a mutable copy of the object.
-
-        Some inventories are immutable, yet working trees, for example, needs
-        to mutate exisiting inventories instead of creating a new one.
-        """
-        return deepcopy(self)
-
-    def _get_mutable_inventory(self):
         """See CommonInventory._get_mutable_inventory."""
         return deepcopy(self)
 

=== added file 'bzrlib/repofmt/groupcompress_repo.py'
--- bzrlib/repofmt/groupcompress_repo.py	1970-01-01 00:00:00 +0000
+++ bzrlib/repofmt/groupcompress_repo.py	2009-04-07 12:32:42 +0000
@@ -0,0 +1,1004 @@
+# Copyright (C) 2008, 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Repostory formats using CHK inventories and groupcompress compression."""
+
+import time
+
+from bzrlib import (
+    bzrdir,
+    chk_map,
+    chk_serializer,
+    debug,
+    errors,
+    index as _mod_index,
+    inventory,
+    knit,
+    osutils,
+    pack,
+    remote,
+    repository,
+    revision as _mod_revision,
+    trace,
+    ui,
+    )
+from bzrlib.btree_index import (
+    BTreeGraphIndex,
+    BTreeBuilder,
+    )
+from bzrlib.index import GraphIndex, GraphIndexBuilder
+from bzrlib.groupcompress import (
+    _GCGraphIndex,
+    GroupCompressVersionedFiles,
+    )
+from bzrlib.repofmt.pack_repo import (
+    Pack,
+    NewPack,
+    KnitPackRepository,
+    PackRootCommitBuilder,
+    RepositoryPackCollection,
+    RepositoryFormatPack,
+    Packer,
+    )
+
+
+class GCPack(NewPack):
+
+    def __init__(self, pack_collection, upload_suffix='', file_mode=None):
+        """Create a NewPack instance.
+
+        :param pack_collection: A PackCollection into which this is being
+            inserted.
+        :param upload_suffix: An optional suffix to be given to any temporary
+            files created during the pack creation. e.g '.autopack'
+        :param file_mode: An optional file mode to create the new files with.
+        """
+        # replaced from NewPack to:
+        # - change inventory reference list length to 1
+        # - change texts reference lists to 1
+        # TODO: patch this to be parameterised
+
+        # The relative locations of the packs are constrained, but all are
+        # passed in because the caller has them, so as to avoid object churn.
+        index_builder_class = pack_collection._index_builder_class
+        # from brisbane-core
+        if pack_collection.chk_index is not None:
+            chk_index = index_builder_class(reference_lists=0)
+        else:
+            chk_index = None
+        Pack.__init__(self,
+            # Revisions: parents list, no text compression.
+            index_builder_class(reference_lists=1),
+            # Inventory: We want to map compression only, but currently the
+            # knit code hasn't been updated enough to understand that, so we
+            # have a regular 2-list index giving parents and compression
+            # source.
+            index_builder_class(reference_lists=1),
+            # Texts: compression and per file graph, for all fileids - so two
+            # reference lists and two elements in the key tuple.
+            index_builder_class(reference_lists=1, key_elements=2),
+            # Signatures: Just blobs to store, no compression, no parents
+            # listing.
+            index_builder_class(reference_lists=0),
+            # CHK based storage - just blobs, no compression or parents.
+            chk_index=chk_index
+            )
+        self._pack_collection = pack_collection
+        # When we make readonly indices, we need this.
+        self.index_class = pack_collection._index_class
+        # where should the new pack be opened
+        self.upload_transport = pack_collection._upload_transport
+        # where are indices written out to
+        self.index_transport = pack_collection._index_transport
+        # where is the pack renamed to when it is finished?
+        self.pack_transport = pack_collection._pack_transport
+        # What file mode to upload the pack and indices with.
+        self._file_mode = file_mode
+        # tracks the content written to the .pack file.
+        self._hash = osutils.md5()
+        # a four-tuple with the length in bytes of the indices, once the pack
+        # is finalised. (rev, inv, text, sigs)
+        self.index_sizes = None
+        # How much data to cache when writing packs. Note that this is not
+        # synchronised with reads, because it's not in the transport layer, so
+        # is not safe unless the client knows it won't be reading from the pack
+        # under creation.
+        self._cache_limit = 0
+        # the temporary pack file name.
+        self.random_name = osutils.rand_chars(20) + upload_suffix
+        # when was this pack started ?
+        self.start_time = time.time()
+        # open an output stream for the data added to the pack.
+        self.write_stream = self.upload_transport.open_write_stream(
+            self.random_name, mode=self._file_mode)
+        if 'pack' in debug.debug_flags:
+            trace.mutter('%s: create_pack: pack stream open: %s%s t+%6.3fs',
+                time.ctime(), self.upload_transport.base, self.random_name,
+                time.time() - self.start_time)
+        # A list of byte sequences to be written to the new pack, and the
+        # aggregate size of them.  Stored as a list rather than separate
+        # variables so that the _write_data closure below can update them.
+        self._buffer = [[], 0]
+        # create a callable for adding data
+        #
+        # robertc says- this is a closure rather than a method on the object
+        # so that the variables are locals, and faster than accessing object
+        # members.
+        def _write_data(bytes, flush=False, _buffer=self._buffer,
+            _write=self.write_stream.write, _update=self._hash.update):
+            _buffer[0].append(bytes)
+            _buffer[1] += len(bytes)
+            # buffer cap
+            if _buffer[1] > self._cache_limit or flush:
+                bytes = ''.join(_buffer[0])
+                _write(bytes)
+                _update(bytes)
+                _buffer[:] = [[], 0]
+        # expose this on self, for the occasion when clients want to add data.
+        self._write_data = _write_data
+        # a pack writer object to serialise pack records.
+        self._writer = pack.ContainerWriter(self._write_data)
+        self._writer.begin()
+        # what state is the pack in? (open, finished, aborted)
+        self._state = 'open'
+
+    def _check_references(self):
+        """Make sure our external references are present.
+
+        Packs are allowed to have deltas whose base is not in the pack, but it
+        must be present somewhere in this collection.  It is not allowed to
+        have deltas based on a fallback repository.
+        (See <https://bugs.launchpad.net/bzr/+bug/288751>)
+        """
+        # Groupcompress packs don't have any external references
+
+
+class GCCHKPacker(Packer):
+    """This class understand what it takes to collect a GCCHK repo."""
+
+    def __init__(self, pack_collection, packs, suffix, revision_ids=None,
+                 reload_func=None):
+        super(GCCHKPacker, self).__init__(pack_collection, packs, suffix,
+                                          revision_ids=revision_ids,
+                                          reload_func=reload_func)
+        self._pack_collection = pack_collection
+        # ATM, We only support this for GCCHK repositories
+        if pack_collection.chk_index is None:
+            raise AssertionError('pack_collection.chk_index should not be None')
+        self._gather_text_refs = False
+        self._chk_id_roots = []
+        self._chk_p_id_roots = []
+        self._text_refs = None
+        # set by .pack() if self.revision_ids is not None
+        self.revision_keys = None
+
+    def _get_progress_stream(self, source_vf, keys, message, pb):
+        def pb_stream():
+            substream = source_vf.get_record_stream(keys, 'groupcompress', True)
+            for idx, record in enumerate(substream):
+                if pb is not None:
+                    pb.update(message, idx + 1, len(keys))
+                yield record
+        return pb_stream()
+
+    def _get_filtered_inv_stream(self, source_vf, keys, message, pb=None):
+        """Filter the texts of inventories, to find the chk pages."""
+        total_keys = len(keys)
+        def _filtered_inv_stream():
+            id_roots_set = set()
+            p_id_roots_set = set()
+            stream = source_vf.get_record_stream(keys, 'groupcompress', True)
+            for idx, record in enumerate(stream):
+                bytes = record.get_bytes_as('fulltext')
+                chk_inv = inventory.CHKInventory.deserialise(None, bytes,
+                                                             record.key)
+                if pb is not None:
+                    pb.update('inv', idx, total_keys)
+                key = chk_inv.id_to_entry.key()
+                if key not in id_roots_set:
+                    self._chk_id_roots.append(key)
+                    id_roots_set.add(key)
+                p_id_map = chk_inv.parent_id_basename_to_file_id
+                if p_id_map is None:
+                    raise AssertionError('Parent id -> file_id map not set')
+                key = p_id_map.key()
+                if key not in p_id_roots_set:
+                    p_id_roots_set.add(key)
+                    self._chk_p_id_roots.append(key)
+                yield record
+            # We have finished processing all of the inventory records, we
+            # don't need these sets anymore
+            id_roots_set.clear()
+            p_id_roots_set.clear()
+        return _filtered_inv_stream()
+
+    def _get_chk_streams(self, source_vf, keys, pb=None):
+        # We want to stream the keys from 'id_roots', and things they
+        # reference, and then stream things from p_id_roots and things they
+        # reference, and then any remaining keys that we didn't get to.
+
+        # We also group referenced texts together, so if one root references a
+        # text with prefix 'a', and another root references a node with prefix
+        # 'a', we want to yield those nodes before we yield the nodes for 'b'
+        # This keeps 'similar' nodes together.
+
+        # Note: We probably actually want multiple streams here, to help the
+        #       client understand that the different levels won't compress well
+        #       against each other.
+        #       Test the difference between using one Group per level, and
+        #       using 1 Group per prefix. (so '' (root) would get a group, then
+        #       all the references to search-key 'a' would get a group, etc.)
+        total_keys = len(keys)
+        remaining_keys = set(keys)
+        counter = [0]
+        if self._gather_text_refs:
+            bytes_to_info = inventory.CHKInventory._bytes_to_utf8name_key
+            self._text_refs = set()
+        def _get_referenced_stream(root_keys, parse_leaf_nodes=False):
+            cur_keys = root_keys
+            while cur_keys:
+                keys_by_search_prefix = {}
+                remaining_keys.difference_update(cur_keys)
+                next_keys = set()
+                def handle_internal_node(node):
+                    for prefix, value in node._items.iteritems():
+                        # We don't want to request the same key twice, and we
+                        # want to order it by the first time it is seen.
+                        # Even further, we don't want to request a key which is
+                        # not in this group of pack files (it should be in the
+                        # repo, but it doesn't have to be in the group being
+                        # packed.)
+                        # TODO: consider how to treat externally referenced chk
+                        #       pages as 'external_references' so that we
+                        #       always fill them in for stacked branches
+                        if value not in next_keys and value in remaining_keys:
+                            keys_by_search_prefix.setdefault(prefix,
+                                []).append(value)
+                            next_keys.add(value)
+                def handle_leaf_node(node):
+                    # Store is None, because we know we have a LeafNode, and we
+                    # just want its entries
+                    for file_id, bytes in node.iteritems(None):
+                        name_utf8, file_id, revision_id = bytes_to_info(bytes)
+                        self._text_refs.add((file_id, revision_id))
+                def next_stream():
+                    stream = source_vf.get_record_stream(cur_keys,
+                                                         'as-requested', True)
+                    for record in stream:
+                        bytes = record.get_bytes_as('fulltext')
+                        # We don't care about search_key_func for this code,
+                        # because we only care about external references.
+                        node = chk_map._deserialise(bytes, record.key,
+                                                    search_key_func=None)
+                        common_base = node._search_prefix
+                        if isinstance(node, chk_map.InternalNode):
+                            handle_internal_node(node)
+                        elif parse_leaf_nodes:
+                            handle_leaf_node(node)
+                        counter[0] += 1
+                        if pb is not None:
+                            pb.update('chk node', counter[0], total_keys)
+                        yield record
+                yield next_stream()
+                # Double check that we won't be emitting any keys twice
+                # If we get rid of the pre-calculation of all keys, we could
+                # turn this around and do
+                # next_keys.difference_update(seen_keys)
+                # However, we also may have references to chk pages in another
+                # pack file during autopack. We filter earlier, so we should no
+                # longer need to do this
+                # next_keys = next_keys.intersection(remaining_keys)
+                cur_keys = []
+                for prefix in sorted(keys_by_search_prefix):
+                    cur_keys.extend(keys_by_search_prefix.pop(prefix))
+        for stream in _get_referenced_stream(self._chk_id_roots,
+                                             self._gather_text_refs):
+            yield stream
+        del self._chk_id_roots
+        # while it isn't really possible for chk_id_roots to not be in the
+        # local group of packs, it is possible that the tree shape has not
+        # changed recently, so we need to filter _chk_p_id_roots by the
+        # available keys
+        chk_p_id_roots = [key for key in self._chk_p_id_roots
+                          if key in remaining_keys]
+        del self._chk_p_id_roots
+        for stream in _get_referenced_stream(chk_p_id_roots, False):
+            yield stream
+        if remaining_keys:
+            trace.mutter('There were %d keys in the chk index, %d of which'
+                         ' were not referenced', total_keys,
+                         len(remaining_keys))
+            if self.revision_ids is None:
+                stream = source_vf.get_record_stream(remaining_keys,
+                                                     'unordered', True)
+                yield stream
+
+    def _build_vf(self, index_name, parents, delta, for_write=False):
+        """Build a VersionedFiles instance on top of this group of packs."""
+        index_name = index_name + '_index'
+        index_to_pack = {}
+        access = knit._DirectPackAccess(index_to_pack)
+        if for_write:
+            # Use new_pack
+            if self.new_pack is None:
+                raise AssertionError('No new pack has been set')
+            index = getattr(self.new_pack, index_name)
+            index_to_pack[index] = self.new_pack.access_tuple()
+            index.set_optimize(for_size=True)
+            access.set_writer(self.new_pack._writer, index,
+                              self.new_pack.access_tuple())
+            add_callback = index.add_nodes
+        else:
+            indices = []
+            for pack in self.packs:
+                sub_index = getattr(pack, index_name)
+                index_to_pack[sub_index] = pack.access_tuple()
+                indices.append(sub_index)
+            index = _mod_index.CombinedGraphIndex(indices)
+            add_callback = None
+        vf = GroupCompressVersionedFiles(
+            _GCGraphIndex(index,
+                          add_callback=add_callback,
+                          parents=parents,
+                          is_locked=self._pack_collection.repo.is_locked),
+            access=access,
+            delta=delta)
+        return vf
+
+    def _build_vfs(self, index_name, parents, delta):
+        """Build the source and target VersionedFiles."""
+        source_vf = self._build_vf(index_name, parents,
+                                   delta, for_write=False)
+        target_vf = self._build_vf(index_name, parents,
+                                   delta, for_write=True)
+        return source_vf, target_vf
+
+    def _copy_stream(self, source_vf, target_vf, keys, message, vf_to_stream,
+                     pb_offset):
+        trace.mutter('repacking %d %s', len(keys), message)
+        self.pb.update('repacking %s' % (message,), pb_offset)
+        child_pb = ui.ui_factory.nested_progress_bar()
+        try:
+            stream = vf_to_stream(source_vf, keys, message, child_pb)
+            for _ in target_vf._insert_record_stream(stream,
+                                                     random_id=True,
+                                                     reuse_blocks=False):
+                pass
+        finally:
+            child_pb.finished()
+
+    def _copy_revision_texts(self):
+        source_vf, target_vf = self._build_vfs('revision', True, False)
+        if not self.revision_keys:
+            # We are doing a full fetch, aka 'pack'
+            self.revision_keys = source_vf.keys()
+        self._copy_stream(source_vf, target_vf, self.revision_keys,
+                          'revisions', self._get_progress_stream, 1)
+
+    def _copy_inventory_texts(self):
+        source_vf, target_vf = self._build_vfs('inventory', True, True)
+        self._copy_stream(source_vf, target_vf, self.revision_keys,
+                          'inventories', self._get_filtered_inv_stream, 2)
+
+    def _copy_chk_texts(self):
+        source_vf, target_vf = self._build_vfs('chk', False, False)
+        # TODO: This is technically spurious... if it is a performance issue,
+        #       remove it
+        total_keys = source_vf.keys()
+        trace.mutter('repacking chk: %d id_to_entry roots,'
+                     ' %d p_id_map roots, %d total keys',
+                     len(self._chk_id_roots), len(self._chk_p_id_roots),
+                     len(total_keys))
+        self.pb.update('repacking chk', 3)
+        child_pb = ui.ui_factory.nested_progress_bar()
+        try:
+            for stream in self._get_chk_streams(source_vf, total_keys,
+                                                pb=child_pb):
+                for _ in target_vf._insert_record_stream(stream,
+                                                         random_id=True,
+                                                         reuse_blocks=False):
+                    pass
+        finally:
+            child_pb.finished()
+
+    def _copy_text_texts(self):
+        source_vf, target_vf = self._build_vfs('text', True, True)
+        # XXX: We don't walk the chk map to determine referenced (file_id,
+        #      revision_id) keys.  We don't do it yet because you really need
+        #      to filter out the ones that are present in the parents of the
+        #      rev just before the ones you are copying, otherwise the filter
+        #      is grabbing too many keys...
+        text_keys = source_vf.keys()
+        self._copy_stream(source_vf, target_vf, text_keys,
+                          'text', self._get_progress_stream, 4)
+
+    def _copy_signature_texts(self):
+        source_vf, target_vf = self._build_vfs('signature', False, False)
+        signature_keys = source_vf.keys()
+        signature_keys.intersection(self.revision_keys)
+        self._copy_stream(source_vf, target_vf, signature_keys,
+                          'signatures', self._get_progress_stream, 5)
+
+    def _create_pack_from_packs(self):
+        self.pb.update('repacking', 0, 7)
+        self.new_pack = self.open_pack()
+        # Is this necessary for GC ?
+        self.new_pack.set_write_cache_size(1024*1024)
+        self._copy_revision_texts()
+        self._copy_inventory_texts()
+        self._copy_chk_texts()
+        self._copy_text_texts()
+        self._copy_signature_texts()
+        self.new_pack._check_references()
+        if not self._use_pack(self.new_pack):
+            self.new_pack.abort()
+            return None
+        self.pb.update('finishing repack', 6, 7)
+        self.new_pack.finish()
+        self._pack_collection.allocate(self.new_pack)
+        return self.new_pack
+
+
+class GCCHKReconcilePacker(GCCHKPacker):
+    """A packer which regenerates indices etc as it copies.
+
+    This is used by ``bzr reconcile`` to cause parent text pointers to be
+    regenerated.
+    """
+
+    def __init__(self, *args, **kwargs):
+        super(GCCHKReconcilePacker, self).__init__(*args, **kwargs)
+        self._data_changed = False
+        self._gather_text_refs = True
+
+    def _copy_inventory_texts(self):
+        source_vf, target_vf = self._build_vfs('inventory', True, True)
+        self._copy_stream(source_vf, target_vf, self.revision_keys,
+                          'inventories', self._get_filtered_inv_stream, 2)
+        if source_vf.keys() != self.revision_keys:
+            self._data_changed = True
+
+    def _copy_text_texts(self):
+        """generate what texts we should have and then copy."""
+        source_vf, target_vf = self._build_vfs('text', True, True)
+        trace.mutter('repacking %d texts', len(self._text_refs))
+        self.pb.update("repacking texts", 4)
+        # we have three major tasks here:
+        # 1) generate the ideal index
+        repo = self._pack_collection.repo
+        # We want the one we just wrote, so base it on self.new_pack
+        revision_vf = self._build_vf('revision', True, False, for_write=True)
+        ancestor_keys = revision_vf.get_parent_map(revision_vf.keys())
+        # Strip keys back into revision_ids.
+        ancestors = dict((k[0], tuple([p[0] for p in parents]))
+                         for k, parents in ancestor_keys.iteritems())
+        del ancestor_keys
+        # TODO: _generate_text_key_index should be much cheaper to generate from
+        #       a chk repository, rather than the current implementation
+        ideal_index = repo._generate_text_key_index(None, ancestors)
+        file_id_parent_map = source_vf.get_parent_map(self._text_refs)
+        # 2) generate a keys list that contains all the entries that can
+        #    be used as-is, with corrected parents.
+        ok_keys = []
+        new_parent_keys = {} # (key, parent_keys)
+        discarded_keys = []
+        NULL_REVISION = _mod_revision.NULL_REVISION
+        for key in self._text_refs:
+            # 0 - index
+            # 1 - key
+            # 2 - value
+            # 3 - refs
+            try:
+                ideal_parents = tuple(ideal_index[key])
+            except KeyError:
+                discarded_keys.append(key)
+                self._data_changed = True
+            else:
+                if ideal_parents == (NULL_REVISION,):
+                    ideal_parents = ()
+                source_parents = file_id_parent_map[key]
+                if ideal_parents == source_parents:
+                    # no change needed.
+                    ok_keys.append(key)
+                else:
+                    # We need to change the parent graph, but we don't need to
+                    # re-insert the text (since we don't pun the compression
+                    # parent with the parents list)
+                    self._data_changed = True
+                    new_parent_keys[key] = ideal_parents
+        # we're finished with some data.
+        del ideal_index
+        del file_id_parent_map
+        # 3) bulk copy the data, updating records than need it
+        def _update_parents_for_texts():
+            stream = source_vf.get_record_stream(self._text_refs,
+                'groupcompress', False)
+            for record in stream:
+                if record.key in new_parent_keys:
+                    record.parents = new_parent_keys[record.key]
+                yield record
+        target_vf.insert_record_stream(_update_parents_for_texts())
+
+    def _use_pack(self, new_pack):
+        """Override _use_pack to check for reconcile having changed content."""
+        return new_pack.data_inserted() and self._data_changed
+
+
+class GCRepositoryPackCollection(RepositoryPackCollection):
+
+    pack_factory = GCPack
+
+    def _already_packed(self):
+        """Is the collection already packed?"""
+        # Always repack GC repositories for now
+        return False
+
+    def _execute_pack_operations(self, pack_operations,
+                                 _packer_class=GCCHKPacker,
+                                 reload_func=None):
+        """Execute a series of pack operations.
+
+        :param pack_operations: A list of [revision_count, packs_to_combine].
+        :param _packer_class: The class of packer to use (default: Packer).
+        :return: None.
+        """
+        # XXX: Copied across from RepositoryPackCollection simply because we
+        #      want to override the _packer_class ... :(
+        for revision_count, packs in pack_operations:
+            # we may have no-ops from the setup logic
+            if len(packs) == 0:
+                continue
+            packer = GCCHKPacker(self, packs, '.autopack',
+                                 reload_func=reload_func)
+            try:
+                packer.pack()
+            except errors.RetryWithNewPacks:
+                # An exception is propagating out of this context, make sure
+                # this packer has cleaned up. Packer() doesn't set its new_pack
+                # state into the RepositoryPackCollection object, so we only
+                # have access to it directly here.
+                if packer.new_pack is not None:
+                    packer.new_pack.abort()
+                raise
+            for pack in packs:
+                self._remove_pack_from_memory(pack)
+        # record the newly available packs and stop advertising the old
+        # packs
+        self._save_pack_names(clear_obsolete_packs=True)
+        # Move the old packs out of the way now they are no longer referenced.
+        for revision_count, packs in pack_operations:
+            self._obsolete_packs(packs)
+
+
+class CHKInventoryRepository(KnitPackRepository):
+    """subclass of KnitPackRepository that uses CHK based inventories."""
+
+    def __init__(self, _format, a_bzrdir, control_files, _commit_builder_class,
+        _serializer):
+        """Overridden to change pack collection class."""
+        KnitPackRepository.__init__(self, _format, a_bzrdir, control_files,
+            _commit_builder_class, _serializer)
+        # and now replace everything it did :)
+        index_transport = self._transport.clone('indices')
+        self._pack_collection = GCRepositoryPackCollection(self,
+            self._transport, index_transport,
+            self._transport.clone('upload'),
+            self._transport.clone('packs'),
+            _format.index_builder_class,
+            _format.index_class,
+            use_chk_index=self._format.supports_chks,
+            )
+        self.inventories = GroupCompressVersionedFiles(
+            _GCGraphIndex(self._pack_collection.inventory_index.combined_index,
+                add_callback=self._pack_collection.inventory_index.add_callback,
+                parents=True, is_locked=self.is_locked),
+            access=self._pack_collection.inventory_index.data_access)
+        self.revisions = GroupCompressVersionedFiles(
+            _GCGraphIndex(self._pack_collection.revision_index.combined_index,
+                add_callback=self._pack_collection.revision_index.add_callback,
+                parents=True, is_locked=self.is_locked),
+            access=self._pack_collection.revision_index.data_access,
+            delta=False)
+        self.signatures = GroupCompressVersionedFiles(
+            _GCGraphIndex(self._pack_collection.signature_index.combined_index,
+                add_callback=self._pack_collection.signature_index.add_callback,
+                parents=False, is_locked=self.is_locked),
+            access=self._pack_collection.signature_index.data_access,
+            delta=False)
+        self.texts = GroupCompressVersionedFiles(
+            _GCGraphIndex(self._pack_collection.text_index.combined_index,
+                add_callback=self._pack_collection.text_index.add_callback,
+                parents=True, is_locked=self.is_locked),
+            access=self._pack_collection.text_index.data_access)
+        # No parents, individual CHK pages don't have specific ancestry
+        self.chk_bytes = GroupCompressVersionedFiles(
+            _GCGraphIndex(self._pack_collection.chk_index.combined_index,
+                add_callback=self._pack_collection.chk_index.add_callback,
+                parents=False, is_locked=self.is_locked),
+            access=self._pack_collection.chk_index.data_access)
+        # True when the repository object is 'write locked' (as opposed to the
+        # physical lock only taken out around changes to the pack-names list.)
+        # Another way to represent this would be a decorator around the control
+        # files object that presents logical locks as physical ones - if this
+        # gets ugly consider that alternative design. RBC 20071011
+        self._write_lock_count = 0
+        self._transaction = None
+        # for tests
+        self._reconcile_does_inventory_gc = True
+        self._reconcile_fixes_text_parents = True
+        self._reconcile_backsup_inventory = False
+
+    def _add_inventory_checked(self, revision_id, inv, parents):
+        """Add inv to the repository after checking the inputs.
+
+        This function can be overridden to allow different inventory styles.
+
+        :seealso: add_inventory, for the contract.
+        """
+        # make inventory
+        serializer = self._format._serializer
+        result = inventory.CHKInventory.from_inventory(self.chk_bytes, inv,
+            maximum_size=serializer.maximum_size,
+            search_key_name=serializer.search_key_name)
+        inv_lines = result.to_lines()
+        return self._inventory_add_lines(revision_id, parents,
+            inv_lines, check_content=False)
+
+    def add_inventory_by_delta(self, basis_revision_id, delta, new_revision_id,
+                               parents, basis_inv=None, propagate_caches=False):
+        """Add a new inventory expressed as a delta against another revision.
+
+        :param basis_revision_id: The inventory id the delta was created
+            against.
+        :param delta: The inventory delta (see Inventory.apply_delta for
+            details).
+        :param new_revision_id: The revision id that the inventory is being
+            added for.
+        :param parents: The revision ids of the parents that revision_id is
+            known to have and are in the repository already. These are supplied
+            for repositories that depend on the inventory graph for revision
+            graph access, as well as for those that pun ancestry with delta
+            compression.
+        :param basis_inv: The basis inventory if it is already known,
+            otherwise None.
+        :param propagate_caches: If True, the caches for this inventory are
+          copied to and updated for the result if possible.
+
+        :returns: (validator, new_inv)
+            The validator(which is a sha1 digest, though what is sha'd is
+            repository format specific) of the serialized inventory, and the
+            resulting inventory.
+        """
+        if basis_revision_id == _mod_revision.NULL_REVISION:
+            return KnitPackRepository.add_inventory_by_delta(self,
+                basis_revision_id, delta, new_revision_id, parents)
+        if not self.is_in_write_group():
+            raise AssertionError("%r not in write group" % (self,))
+        _mod_revision.check_not_reserved_id(new_revision_id)
+        basis_tree = self.revision_tree(basis_revision_id)
+        basis_tree.lock_read()
+        try:
+            if basis_inv is None:
+                basis_inv = basis_tree.inventory
+            result = basis_inv.create_by_apply_delta(delta, new_revision_id,
+                propagate_caches=propagate_caches)
+            inv_lines = result.to_lines()
+            return self._inventory_add_lines(new_revision_id, parents,
+                inv_lines, check_content=False), result
+        finally:
+            basis_tree.unlock()
+
+    def _iter_inventories(self, revision_ids):
+        """Iterate over many inventory objects."""
+        keys = [(revision_id,) for revision_id in revision_ids]
+        stream = self.inventories.get_record_stream(keys, 'unordered', True)
+        texts = {}
+        for record in stream:
+            if record.storage_kind != 'absent':
+                texts[record.key] = record.get_bytes_as('fulltext')
+            else:
+                raise errors.NoSuchRevision(self, record.key)
+        for key in keys:
+            yield inventory.CHKInventory.deserialise(self.chk_bytes, texts[key], key)
+
+    def _iter_inventory_xmls(self, revision_ids):
+        # Without a native 'xml' inventory, this method doesn't make sense, so
+        # make it raise to trap naughty direct users.
+        raise NotImplementedError(self._iter_inventory_xmls)
+
+    def _find_revision_outside_set(self, revision_ids):
+        revision_set = frozenset(revision_ids)
+        for revid in revision_ids:
+            parent_ids = self.get_parent_map([revid]).get(revid, ())
+            for parent in parent_ids:
+                if parent in revision_set:
+                    # Parent is not outside the set
+                    continue
+                if parent not in self.get_parent_map([parent]):
+                    # Parent is a ghost
+                    continue
+                return parent
+        return _mod_revision.NULL_REVISION
+
+    def _find_file_keys_to_fetch(self, revision_ids, pb):
+        rich_root = self.supports_rich_root()
+        revision_outside_set = self._find_revision_outside_set(revision_ids)
+        if revision_outside_set == _mod_revision.NULL_REVISION:
+            uninteresting_root_keys = set()
+        else:
+            uninteresting_inv = self.get_inventory(revision_outside_set)
+            uninteresting_root_keys = set([uninteresting_inv.id_to_entry.key()])
+        interesting_root_keys = set()
+        for idx, inv in enumerate(self.iter_inventories(revision_ids)):
+            interesting_root_keys.add(inv.id_to_entry.key())
+        revision_ids = frozenset(revision_ids)
+        file_id_revisions = {}
+        bytes_to_info = inventory.CHKInventory._bytes_to_utf8name_key
+        for record, items in chk_map.iter_interesting_nodes(self.chk_bytes,
+                    interesting_root_keys, uninteresting_root_keys,
+                    pb=pb):
+            # This is cheating a bit to use the last grabbed 'inv', but it
+            # works
+            for name, bytes in items:
+                (name_utf8, file_id, revision_id) = bytes_to_info(bytes)
+                if not rich_root and name_utf8 == '':
+                    continue
+                if revision_id in revision_ids:
+                    # Would we rather build this up into file_id => revision
+                    # maps?
+                    try:
+                        file_id_revisions[file_id].add(revision_id)
+                    except KeyError:
+                        file_id_revisions[file_id] = set([revision_id])
+        for file_id, revisions in file_id_revisions.iteritems():
+            yield ('file', file_id, revisions)
+
+    def fileids_altered_by_revision_ids(self, revision_ids, _inv_weave=None):
+        """Find the file ids and versions affected by revisions.
+
+        :param revisions: an iterable containing revision ids.
+        :param _inv_weave: The inventory weave from this repository or None.
+            If None, the inventory weave will be opened automatically.
+        :return: a dictionary mapping altered file-ids to an iterable of
+            revision_ids. Each altered file-ids has the exact revision_ids that
+            altered it listed explicitly.
+        """
+        rich_roots = self.supports_rich_root()
+        result = {}
+        pb = ui.ui_factory.nested_progress_bar()
+        try:
+            total = len(revision_ids)
+            for pos, inv in enumerate(self.iter_inventories(revision_ids)):
+                pb.update("Finding text references", pos, total)
+                for entry in inv.iter_just_entries():
+                    if entry.revision != inv.revision_id:
+                        continue
+                    if not rich_roots and entry.file_id == inv.root_id:
+                        continue
+                    alterations = result.setdefault(entry.file_id, set([]))
+                    alterations.add(entry.revision)
+            return result
+        finally:
+            pb.finished()
+
+    def find_text_key_references(self):
+        """Find the text key references within the repository.
+
+        :return: A dictionary mapping text keys ((fileid, revision_id) tuples)
+            to whether they were referred to by the inventory of the
+            revision_id that they contain. The inventory texts from all present
+            revision ids are assessed to generate this report.
+        """
+        # XXX: Slow version but correct: rewrite as a series of delta
+        # examinations/direct tree traversal. Note that that will require care
+        # as a common node is reachable both from the inventory that added it,
+        # and others afterwards.
+        revision_keys = self.revisions.keys()
+        result = {}
+        rich_roots = self.supports_rich_root()
+        pb = ui.ui_factory.nested_progress_bar()
+        try:
+            all_revs = self.all_revision_ids()
+            total = len(all_revs)
+            for pos, inv in enumerate(self.iter_inventories(all_revs)):
+                pb.update("Finding text references", pos, total)
+                for _, entry in inv.iter_entries():
+                    if not rich_roots and entry.file_id == inv.root_id:
+                        continue
+                    key = (entry.file_id, entry.revision)
+                    result.setdefault(key, False)
+                    if entry.revision == inv.revision_id:
+                        result[key] = True
+            return result
+        finally:
+            pb.finished()
+
+    def _reconcile_pack(self, collection, packs, extension, revs, pb):
+        packer = GCCHKReconcilePacker(collection, packs, extension)
+        return packer.pack(pb)
+
+    def _get_source(self, to_format):
+        """Return a source for streaming from this repository."""
+        if isinstance(to_format, remote.RemoteRepositoryFormat):
+            # Can't just check attributes on to_format with the current code,
+            # work around this:
+            to_format._ensure_real()
+            to_format = to_format._custom_format
+        if to_format.__class__ is self._format.__class__:
+            # We must be exactly the same format, otherwise stuff like the chk
+            # page layout might be different
+            return GroupCHKStreamSource(self, to_format)
+        return super(CHKInventoryRepository, self)._get_source(to_format)
+
+    def suspend_write_group(self):
+        raise errors.UnsuspendableWriteGroup(self)
+
+    def _resume_write_group(self, tokens):
+        raise errors.UnsuspendableWriteGroup(self)
+
+
+class GroupCHKStreamSource(repository.StreamSource):
+    """Used when both the source and target repo are GroupCHK repos."""
+
+    def __init__(self, from_repository, to_format):
+        """Create a StreamSource streaming from from_repository."""
+        super(GroupCHKStreamSource, self).__init__(from_repository, to_format)
+        self._revision_keys = None
+        self._text_keys = None
+        self._chk_id_roots = None
+        self._chk_p_id_roots = None
+
+    def _get_filtered_inv_stream(self):
+        """Get a stream of inventory texts.
+
+        When this function returns, self._chk_id_roots and self._chk_p_id_roots
+        should be populated.
+        """
+        self._chk_id_roots = []
+        self._chk_p_id_roots = []
+        def _filtered_inv_stream():
+            id_roots_set = set()
+            p_id_roots_set = set()
+            source_vf = self.from_repository.inventories
+            stream = source_vf.get_record_stream(self._revision_keys,
+                                                 'groupcompress', True)
+            for record in stream:
+                bytes = record.get_bytes_as('fulltext')
+                chk_inv = inventory.CHKInventory.deserialise(None, bytes,
+                                                             record.key)
+                key = chk_inv.id_to_entry.key()
+                if key not in id_roots_set:
+                    self._chk_id_roots.append(key)
+                    id_roots_set.add(key)
+                p_id_map = chk_inv.parent_id_basename_to_file_id
+                if p_id_map is None:
+                    raise AssertionError('Parent id -> file_id map not set')
+                key = p_id_map.key()
+                if key not in p_id_roots_set:
+                    p_id_roots_set.add(key)
+                    self._chk_p_id_roots.append(key)
+                yield record
+            # We have finished processing all of the inventory records, we
+            # don't need these sets anymore
+            id_roots_set.clear()
+            p_id_roots_set.clear()
+        return ('inventories', _filtered_inv_stream())
+
+    def _get_filtered_chk_streams(self, excluded_keys):
+        self._text_keys = set()
+        excluded_keys.discard(_mod_revision.NULL_REVISION)
+        if not excluded_keys:
+            uninteresting_root_keys = set()
+            uninteresting_pid_root_keys = set()
+        else:
+            uninteresting_root_keys = set()
+            uninteresting_pid_root_keys = set()
+            for inv in self.from_repository.iter_inventories(excluded_keys):
+                uninteresting_root_keys.add(inv.id_to_entry.key())
+                uninteresting_pid_root_keys.add(
+                    inv.parent_id_basename_to_file_id.key())
+        bytes_to_info = inventory.CHKInventory._bytes_to_utf8name_key
+        chk_bytes = self.from_repository.chk_bytes
+        def _filter_id_to_entry():
+            for record, items in chk_map.iter_interesting_nodes(chk_bytes,
+                        self._chk_id_roots, uninteresting_root_keys):
+                for name, bytes in items:
+                    # Note: we don't care about name_utf8, because we are always
+                    # rich-root = True
+                    _, file_id, revision_id = bytes_to_info(bytes)
+                    self._text_keys.add((file_id, revision_id))
+                if record is not None:
+                    yield record
+        yield 'chk_bytes', _filter_id_to_entry()
+        def _get_parent_id_basename_to_file_id_pages():
+            for record, items in chk_map.iter_interesting_nodes(chk_bytes,
+                        self._chk_p_id_roots, uninteresting_pid_root_keys):
+                if record is not None:
+                    yield record
+        yield 'chk_bytes', _get_parent_id_basename_to_file_id_pages()
+
+    def _get_text_stream(self):
+        # Note: We know we don't have to handle adding root keys, because both
+        # the source and target are GCCHK, and those always support rich-roots
+        # We may want to request as 'unordered', in case the source has done a
+        # 'split' packing
+        return ('texts', self.from_repository.texts.get_record_stream(
+                            self._text_keys, 'groupcompress', False))
+
+    def get_stream(self, search):
+        revision_ids = search.get_keys()
+        for stream_info in self._fetch_revision_texts(revision_ids):
+            yield stream_info
+        self._revision_keys = [(rev_id,) for rev_id in revision_ids]
+        yield self._get_filtered_inv_stream()
+        # The keys to exclude are part of the search recipe
+        _, _, exclude_keys, _ = search.get_recipe()
+        for stream_info in self._get_filtered_chk_streams(exclude_keys):
+            yield stream_info
+        yield self._get_text_stream()
+
+
+class RepositoryFormatCHK1(RepositoryFormatPack):
+    """A hashed CHK+group compress pack repository."""
+
+    repository_class = CHKInventoryRepository
+    supports_chks = True
+    # For right now, setting this to True gives us InterModel1And2 rather
+    # than InterDifferingSerializer
+    _commit_builder_class = PackRootCommitBuilder
+    rich_root_data = True
+    _serializer = chk_serializer.chk_serializer_255_bigpage
+    _commit_inv_deltas = True
+    # What index classes to use
+    index_builder_class = BTreeBuilder
+    index_class = BTreeGraphIndex
+    # Note: We cannot unpack a delta that references a text we haven't
+    # seen yet. There are 2 options, work in fulltexts, or require
+    # topological sorting. Using fulltexts is more optimal for local
+    # operations, because the source can be smart about extracting
+    # multiple in-a-row (and sharing strings). Topological is better
+    # for remote, because we access less data.
+    _fetch_order = 'unordered'
+    _fetch_uses_deltas = True # essentially ignored by the groupcompress code.
+    fast_deltas = True
+
+    def _get_matching_bzrdir(self):
+        return bzrdir.format_registry.make_bzrdir('development6-rich-root')
+
+    def _ignore_setting_bzrdir(self, format):
+        pass
+
+    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
+
+    def get_format_string(self):
+        """See RepositoryFormat.get_format_string()."""
+        return ('Bazaar development format - group compression and chk inventory'
+                ' (needs bzr.dev from 1.14)\n')
+
+    def get_format_description(self):
+        """See RepositoryFormat.get_format_description()."""
+        return ("Development repository format - rich roots, group compression"
+            " and chk inventories")
+
+    def check_conversion_target(self, target_format):
+        if not target_format.rich_root_data:
+            raise errors.BadConversionTarget(
+                'Does not support rich root data.', target_format)
+        if not getattr(target_format, 'supports_tree_reference', False):
+            raise errors.BadConversionTarget(
+                'Does not support nested trees', target_format)
+
+

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2009-04-03 13:08:27 +0000
+++ bzrlib/repofmt/pack_repo.py	2009-04-07 12:32:42 +0000
@@ -23,6 +23,7 @@
 import time
 
 from bzrlib import (
+    chk_map,
     debug,
     graph,
     osutils,
@@ -53,6 +54,7 @@
     errors,
     lockable_files,
     lockdir,
+    revision as _mod_revision,
     symbol_versioning,
     )
 
@@ -131,6 +133,7 @@
     # A map of index 'type' to the file extension and position in the
     # index_sizes array.
     index_definitions = {
+        'chk': ('.cix', 4),
         'revision': ('.rix', 0),
         'inventory': ('.iix', 1),
         'text': ('.tix', 2),
@@ -138,7 +141,7 @@
         }
 
     def __init__(self, revision_index, inventory_index, text_index,
-        signature_index):
+        signature_index, chk_index=None):
         """Create a pack instance.
 
         :param revision_index: A GraphIndex for determining what revisions are
@@ -151,11 +154,14 @@
             texts/deltas (via (fileid, revisionid) tuples).
         :param signature_index: A GraphIndex for determining what signatures are
             present in the Pack and accessing the locations of their texts.
+        :param chk_index: A GraphIndex for accessing content by CHK, if the
+            pack has one.
         """
         self.revision_index = revision_index
         self.inventory_index = inventory_index
         self.text_index = text_index
         self.signature_index = signature_index
+        self.chk_index = chk_index
 
     def access_tuple(self):
         """Return a tuple (transport, name) for the pack content."""
@@ -232,14 +238,14 @@
     """An in memory proxy for an existing .pack and its disk indices."""
 
     def __init__(self, pack_transport, name, revision_index, inventory_index,
-        text_index, signature_index):
+        text_index, signature_index, chk_index=None):
         """Create an ExistingPack object.
 
         :param pack_transport: The transport where the pack file resides.
         :param name: The name of the pack on disk in the pack_transport.
         """
         Pack.__init__(self, revision_index, inventory_index, text_index,
-            signature_index)
+            signature_index, chk_index)
         self.name = name
         self.pack_transport = pack_transport
         if None in (revision_index, inventory_index, text_index,
@@ -327,6 +333,10 @@
         # The relative locations of the packs are constrained, but all are
         # passed in because the caller has them, so as to avoid object churn.
         index_builder_class = pack_collection._index_builder_class
+        if pack_collection.chk_index is not None:
+            chk_index = index_builder_class(reference_lists=0)
+        else:
+            chk_index = None
         Pack.__init__(self,
             # Revisions: parents list, no text compression.
             index_builder_class(reference_lists=1),
@@ -341,6 +351,8 @@
             # Signatures: Just blobs to store, no compression, no parents
             # listing.
             index_builder_class(reference_lists=0),
+            # CHK based storage - just blobs, no compression or parents.
+            chk_index=chk_index
             )
         self._pack_collection = pack_collection
         # When we make readonly indices, we need this.
@@ -355,8 +367,8 @@
         self._file_mode = file_mode
         # tracks the content written to the .pack file.
         self._hash = osutils.md5()
-        # a four-tuple with the length in bytes of the indices, once the pack
-        # is finalised. (rev, inv, text, sigs)
+        # a tuple with the length in bytes of the indices, once the pack
+        # is finalised. (rev, inv, text, sigs, chk_if_in_use)
         self.index_sizes = None
         # How much data to cache when writing packs. Note that this is not
         # synchronised with reads, because it's not in the transport layer, so
@@ -423,7 +435,8 @@
         return bool(self.get_revision_count() or
             self.inventory_index.key_count() or
             self.text_index.key_count() or
-            self.signature_index.key_count())
+            self.signature_index.key_count() or
+            (self.chk_index is not None and self.chk_index.key_count()))
 
     def finish(self, suspend=False):
         """Finish the new pack.
@@ -454,6 +467,10 @@
         self._write_index('text', self.text_index, 'file texts', suspend)
         self._write_index('signature', self.signature_index,
             'revision signatures', suspend)
+        if self.chk_index is not None:
+            self.index_sizes.append(None)
+            self._write_index('chk', self.chk_index,
+                'content hash bytes', suspend)
         self.write_stream.close()
         # Note that this will clobber an existing pack with the same name,
         # without checking for hash collisions. While this is undesirable this
@@ -726,7 +743,8 @@
 
     def open_pack(self):
         """Open a pack for the pack we are creating."""
-        new_pack = NewPack(self._pack_collection, upload_suffix=self.suffix,
+        new_pack = self._pack_collection.pack_factory(self._pack_collection,
+                upload_suffix=self.suffix,
                 file_mode=self._pack_collection.repo.bzrdir._get_file_mode())
         # We know that we will process all nodes in order, and don't need to
         # query, so don't combine any indices spilled to disk until we are done
@@ -897,6 +915,17 @@
                 time.ctime(), self._pack_collection._upload_transport.base, new_pack.random_name,
                 new_pack.signature_index.key_count(),
                 time.time() - new_pack.start_time)
+        # copy chk contents
+        # NB XXX: how to check CHK references are present? perhaps by yielding
+        # the items? How should that interact with stacked repos?
+        if new_pack.chk_index is not None:
+            self._copy_chks()
+            if 'pack' in debug.debug_flags:
+                mutter('%s: create_pack: chk content copied: %s%s %d items t+%6.3fs',
+                    time.ctime(), self._pack_collection._upload_transport.base,
+                    new_pack.random_name,
+                    new_pack.chk_index.key_count(),
+                    time.time() - new_pack.start_time)
         new_pack._check_references()
         if not self._use_pack(new_pack):
             new_pack.abort()
@@ -906,16 +935,43 @@
         self._pack_collection.allocate(new_pack)
         return new_pack
 
-    def _copy_nodes(self, nodes, index_map, writer, write_index):
-        """Copy knit nodes between packs with no graph references."""
+    def _copy_chks(self, refs=None):
+        # XXX: Todo, recursive follow-pointers facility when fetching some
+        # revisions only.
+        chk_index_map, chk_indices = self._pack_map_and_index_list(
+            'chk_index')
+        chk_nodes = self._index_contents(chk_indices, refs)
+        new_refs = set()
+        # TODO: This isn't strictly tasteful as we are accessing some private
+        #       variables (_serializer). Perhaps a better way would be to have
+        #       Repository._deserialise_chk_node()
+        search_key_func = chk_map.search_key_registry.get(
+            self._pack_collection.repo._serializer.search_key_name)
+        def accumlate_refs(lines):
+            # XXX: move to a generic location
+            # Yay mismatch:
+            bytes = ''.join(lines)
+            node = chk_map._deserialise(bytes, ("unknown",), search_key_func)
+            new_refs.update(node.refs())
+        self._copy_nodes(chk_nodes, chk_index_map, self.new_pack._writer,
+            self.new_pack.chk_index, output_lines=accumlate_refs)
+        return new_refs
+
+    def _copy_nodes(self, nodes, index_map, writer, write_index,
+        output_lines=None):
+        """Copy knit nodes between packs with no graph references.
+
+        :param output_lines: Output full texts of copied items.
+        """
         pb = ui.ui_factory.nested_progress_bar()
         try:
             return self._do_copy_nodes(nodes, index_map, writer,
-                write_index, pb)
+                write_index, pb, output_lines=output_lines)
         finally:
             pb.finished()
 
-    def _do_copy_nodes(self, nodes, index_map, writer, write_index, pb):
+    def _do_copy_nodes(self, nodes, index_map, writer, write_index, pb,
+        output_lines=None):
         # for record verification
         knit = KnitVersionedFiles(None, None)
         # plan a readv on each source pack:
@@ -955,8 +1011,11 @@
                 izip(reader.iter_records(), pack_readv_requests):
                 raw_data = read_func(None)
                 # check the header only
-                df, _ = knit._parse_record_header(key, raw_data)
-                df.close()
+                if output_lines is not None:
+                    output_lines(knit._parse_record(key[-1], raw_data)[0])
+                else:
+                    df, _ = knit._parse_record_header(key, raw_data)
+                    df.close()
                 pos, size = writer.add_bytes_record(raw_data, names)
                 write_index.add_node(key, eol_flag + "%d %d" % (pos, size))
                 pb.update("Copied record", record_index)
@@ -1292,8 +1351,11 @@
     :ivar _names: map of {pack_name: (index_size,)}
     """
 
+    pack_factory = NewPack
+
     def __init__(self, repo, transport, index_transport, upload_transport,
-                 pack_transport, index_builder_class, index_class):
+                 pack_transport, index_builder_class, index_class,
+                 use_chk_index):
         """Create a new RepositoryPackCollection.
 
         :param transport: Addresses the repository base directory
@@ -1304,6 +1366,7 @@
         :param pack_transport: Addresses the directory of existing complete packs.
         :param index_builder_class: The index builder class to use.
         :param index_class: The index class to use.
+        :param use_chk_index: Whether to setup and manage a CHK index.
         """
         # XXX: This should call self.reset()
         self.repo = repo
@@ -1313,7 +1376,8 @@
         self._pack_transport = pack_transport
         self._index_builder_class = index_builder_class
         self._index_class = index_class
-        self._suffix_offsets = {'.rix': 0, '.iix': 1, '.tix': 2, '.six': 3}
+        self._suffix_offsets = {'.rix': 0, '.iix': 1, '.tix': 2, '.six': 3,
+            '.cix': 4}
         self.packs = []
         # name:Pack mapping
         self._names = None
@@ -1328,6 +1392,11 @@
         self.inventory_index = AggregateIndex(self.reload_pack_names, flush)
         self.text_index = AggregateIndex(self.reload_pack_names, flush)
         self.signature_index = AggregateIndex(self.reload_pack_names, flush)
+        if use_chk_index:
+            self.chk_index = AggregateIndex(self.reload_pack_names, flush)
+        else:
+            # used to determine if we're using a chk_index elsewhere.
+            self.chk_index = None
         # resumed packs
         self._resumed_packs = []
 
@@ -1345,6 +1414,8 @@
         self.inventory_index.add_index(pack.inventory_index, pack)
         self.text_index.add_index(pack.text_index, pack)
         self.signature_index.add_index(pack.signature_index, pack)
+        if self.chk_index is not None:
+            self.chk_index.add_index(pack.chk_index, pack)
 
     def all_packs(self):
         """Return a list of all the Pack objects this repository has.
@@ -1388,8 +1459,6 @@
         total_packs = len(self._names)
         if self._max_pack_count(total_revisions) >= total_packs:
             return False
-        # XXX: the following may want to be a class, to pack with a given
-        # policy.
         # determine which packs need changing
         pack_distribution = self.pack_distribution(total_revisions)
         existing_packs = []
@@ -1419,6 +1488,7 @@
             num_new_packs, num_revs_affected)
         self._execute_pack_operations(pack_operations,
                                       reload_func=self._restart_autopack)
+        mutter('Auto-packing repository %s completed', self)
         return True
 
     def _execute_pack_operations(self, pack_operations, _packer_class=Packer,
@@ -1466,11 +1536,15 @@
         """
         self.repo.control_files.lock_write()
 
+    def _already_packed(self):
+        """Is the collection already packed?"""
+        return len(self._names) < 2
+
     def pack(self):
         """Pack the pack collection totally."""
         self.ensure_loaded()
         total_packs = len(self._names)
-        if total_packs < 2:
+        if self._already_packed():
             # This is arguably wrong because we might not be optimal, but for
             # now lets leave it in. (e.g. reconcile -> one pack. But not
             # optimal.
@@ -1581,8 +1655,12 @@
             inv_index = self._make_index(name, '.iix')
             txt_index = self._make_index(name, '.tix')
             sig_index = self._make_index(name, '.six')
+            if self.chk_index is not None:
+                chk_index = self._make_index(name, '.cix')
+            else:
+                chk_index = None
             result = ExistingPack(self._pack_transport, name, rev_index,
-                inv_index, txt_index, sig_index)
+                inv_index, txt_index, sig_index, chk_index)
             self.add_pack_to_memory(result)
             return result
 
@@ -1682,7 +1760,10 @@
             # TODO: Probably needs to know all possible indices for this pack
             # - or maybe list the directory and move all indices matching this
             # name whether we recognize it or not?
-            for suffix in ('.iix', '.six', '.tix', '.rix'):
+            suffixes = ['.iix', '.six', '.tix', '.rix']
+            if self.chk_index is not None:
+                suffixes.append('.cix')
+            for suffix in suffixes:
                 self._index_transport.rename(pack.name + suffix,
                     '../obsolete_packs/' + pack.name + suffix)
 
@@ -1722,6 +1803,8 @@
         self.inventory_index.remove_index(pack.inventory_index, pack)
         self.text_index.remove_index(pack.text_index, pack)
         self.signature_index.remove_index(pack.signature_index, pack)
+        if self.chk_index is not None:
+            self.chk_index.remove_index(pack.chk_index, pack)
 
     def reset(self):
         """Clear all cached data."""
@@ -1736,6 +1819,9 @@
         self.repo._text_knit = None
         # cached inventory data
         self.inventory_index.clear()
+        # cached chk data
+        if self.chk_index is not None:
+            self.chk_index.clear()
         # remove the open pack
         self._new_pack = None
         # information about packs.
@@ -1903,7 +1989,7 @@
         # Do not permit preparation for writing if we're not in a 'write lock'.
         if not self.repo.is_write_locked():
             raise errors.NotWriteLocked(self)
-        self._new_pack = NewPack(self, upload_suffix='.pack',
+        self._new_pack = self.pack_factory(self, upload_suffix='.pack',
             file_mode=self.repo.bzrdir._get_file_mode())
         # allow writing: queue writes to a new index
         self.revision_index.add_writable_index(self._new_pack.revision_index,
@@ -1912,8 +1998,14 @@
             self._new_pack)
         self.text_index.add_writable_index(self._new_pack.text_index,
             self._new_pack)
+        self._new_pack.text_index.set_optimize(combine_backing_indices=False)
         self.signature_index.add_writable_index(self._new_pack.signature_index,
             self._new_pack)
+        if self.chk_index is not None:
+            self.chk_index.add_writable_index(self._new_pack.chk_index,
+                self._new_pack)
+            self.repo.chk_bytes._index._add_callback = self.chk_index.add_callback
+            self._new_pack.chk_index.set_optimize(combine_backing_indices=False)
 
         self.repo.inventories._index._add_callback = self.inventory_index.add_callback
         self.repo.revisions._index._add_callback = self.revision_index.add_callback
@@ -2046,7 +2138,9 @@
             self._transport.clone('upload'),
             self._transport.clone('packs'),
             _format.index_builder_class,
-            _format.index_class)
+            _format.index_class,
+            use_chk_index=self._format.supports_chks,
+            )
         self.inventories = KnitVersionedFiles(
             _KnitGraphIndex(self._pack_collection.inventory_index.combined_index,
                 add_callback=self._pack_collection.inventory_index.add_callback,
@@ -2071,7 +2165,18 @@
                 deltas=True, parents=True, is_locked=self.is_locked),
             data_access=self._pack_collection.text_index.data_access,
             max_delta_chain=200)
-        self.chk_bytes = None
+        if _format.supports_chks:
+            # No graph, no compression:- references from chks are between
+            # different objects not temporal versions of the same; and without
+            # some sort of temporal structure knit compression will just fail.
+            self.chk_bytes = KnitVersionedFiles(
+                _KnitGraphIndex(self._pack_collection.chk_index.combined_index,
+                    add_callback=self._pack_collection.chk_index.add_callback,
+                    deltas=False, parents=False, is_locked=self.is_locked),
+                data_access=self._pack_collection.chk_index.data_access,
+                max_delta_chain=0)
+        else:
+            self.chk_bytes = None
         # True when the repository object is 'write locked' (as opposed to the
         # physical lock only taken out around changes to the pack-names list.)
         # Another way to represent this would be a decorator around the control
@@ -2112,28 +2217,34 @@
             revision_nodes = self._pack_collection.revision_index \
                 .combined_index.iter_all_entries()
             index_positions = []
-            # Get the cached index values for all revisions, and also the location
-            # in each index of the revision text so we can perform linear IO.
+            # Get the cached index values for all revisions, and also the
+            # location in each index of the revision text so we can perform
+            # linear IO.
             for index, key, value, refs in revision_nodes:
-                pos, length = value[1:].split(' ')
-                index_positions.append((index, int(pos), key[0],
-                    tuple(parent[0] for parent in refs[0])))
+                node = (index, key, value, refs)
+                index_memo = self.revisions._index._node_to_position(node)
+                if index_memo[0] != index:
+                    raise AssertionError('%r != %r' % (index_memo[0], index))
+                index_positions.append((index_memo, key[0],
+                                       tuple(parent[0] for parent in refs[0])))
                 pb.update("Reading revision index", 0, 0)
             index_positions.sort()
-            batch_count = len(index_positions) / 1000 + 1
-            pb.update("Checking cached revision graph", 0, batch_count)
-            for offset in xrange(batch_count):
+            batch_size = 1000
+            pb.update("Checking cached revision graph", 0,
+                      len(index_positions))
+            for offset in xrange(0, len(index_positions), 1000):
                 pb.update("Checking cached revision graph", offset)
-                to_query = index_positions[offset * 1000:(offset + 1) * 1000]
+                to_query = index_positions[offset:offset + batch_size]
                 if not to_query:
                     break
-                rev_ids = [item[2] for item in to_query]
+                rev_ids = [item[1] for item in to_query]
                 revs = self.get_revisions(rev_ids)
                 for revision, item in zip(revs, to_query):
-                    index_parents = item[3]
+                    index_parents = item[2]
                     rev_parents = tuple(revision.parent_ids)
                     if index_parents != rev_parents:
-                        result.append((revision.revision_id, index_parents, rev_parents))
+                        result.append((revision.revision_id, index_parents,
+                                       rev_parents))
         finally:
             pb.finished()
         return result
@@ -2667,55 +2778,15 @@
         return "Packs 6 rich-root (uses btree indexes, requires bzr 1.9)"
 
 
-class RepositoryFormatPackDevelopment2(RepositoryFormatPack):
-    """A no-subtrees development repository.
-
-    This format should be retained until the second release after bzr 1.7.
-
-    This is pack-1.6.1 with B+Tree indices.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackCommitBuilder
-    supports_external_lookups = True
-    # What index classes to use
-    index_builder_class = BTreeBuilder
-    index_class = BTreeGraphIndex
-    # Set to true to get the fast-commit code path tested until a really fast
-    # format lands in trunk. Not actually fast in this format.
-    fast_deltas = True
-
-    @property
-    def _serializer(self):
-        return xml5.serializer_v5
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir('development2')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return "Bazaar development format 2 (needs bzr.dev from before 1.8)\n"
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return ("Development repository format, currently the same as "
-            "1.6.1 with B+Trees.\n")
-
-    def check_conversion_target(self, target_format):
-        pass
-
-
 class RepositoryFormatPackDevelopment2Subtree(RepositoryFormatPack):
     """A subtrees development repository.
 
     This format should be retained until the second release after bzr 1.7.
 
     1.6.1-subtree[as it might have been] with B+Tree indices.
+
+    This is [now] retained until we have a CHK based subtree format in
+    development.
     """
 
     repository_class = KnitPackRepository
@@ -2733,7 +2804,7 @@
 
     def _get_matching_bzrdir(self):
         return bzrdir.format_registry.make_bzrdir(
-            'development2-subtree')
+            'development-subtree')
 
     def _ignore_setting_bzrdir(self, format):
         pass
@@ -2757,3 +2828,4 @@
         """See RepositoryFormat.get_format_description()."""
         return ("Development repository format, currently the same as "
             "1.6.1-subtree with B+Tree indices.\n")
+

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2009-04-04 02:50:01 +0000
+++ bzrlib/repository.py	2009-04-07 12:32:42 +0000
@@ -23,12 +23,14 @@
 from bzrlib import (
     bzrdir,
     check,
+    chk_map,
     debug,
     errors,
     fifo_cache,
     generate_ids,
     gpg,
     graph,
+    inventory,
     lazy_regex,
     lockable_files,
     lockdir,
@@ -197,7 +199,7 @@
 
     def finish_inventory(self):
         """Tell the builder that the inventory is finished.
-        
+
         :return: The inventory id in the repository, which can be used with
             repository.get_inventory.
         """
@@ -866,16 +868,18 @@
     which views a particular line of development through that history.
 
     The Repository builds on top of some byte storage facilies (the revisions,
-    signatures, inventories and texts attributes) and a Transport, which
-    respectively provide byte storage and a means to access the (possibly
+    signatures, inventories, texts and chk_bytes attributes) and a Transport,
+    which respectively provide byte storage and a means to access the (possibly
     remote) disk.
 
     The byte storage facilities are addressed via tuples, which we refer to
     as 'keys' throughout the code base. Revision_keys, inventory_keys and
     signature_keys are all 1-tuples: (revision_id,). text_keys are two-tuples:
-    (file_id, revision_id). We use this interface because it allows low
-    friction with the underlying code that implements disk indices, network
-    encoding and other parts of bzrlib.
+    (file_id, revision_id). chk_bytes uses CHK keys - a 1-tuple with a single
+    byte string made up of a hash identifier and a hash value.
+    We use this interface because it allows low friction with the underlying
+    code that implements disk indices, network encoding and other parts of
+    bzrlib.
 
     :ivar revisions: A bzrlib.versionedfile.VersionedFiles instance containing
         the serialised revisions for the repository. This can be used to obtain
@@ -900,6 +904,11 @@
         The result of trying to insert data into the repository via this store
         is undefined: it should be considered read-only except for implementors
         of repositories.
+    :ivar chk_bytes: A bzrlib.versionedfile.VersionedFiles instance containing
+        any data the repository chooses to store or have indexed by its hash.
+        The result of trying to insert data into the repository via this store
+        is undefined: it should be considered read-only except for implementors
+        of repositories.
     :ivar _transport: Transport for file access to repository, typically
         pointing to .bzr/repository.
     """
@@ -926,7 +935,9 @@
         """
         if self._write_group is not self.get_transaction():
             # has an unlock or relock occured ?
-            raise errors.BzrError('mismatched lock context and write group.')
+            raise errors.BzrError(
+                'mismatched lock context and write group. %r, %r' %
+                (self._write_group, self.get_transaction()))
         try:
             self._abort_write_group()
         except Exception, exc:
@@ -964,6 +975,8 @@
         self.inventories.add_fallback_versioned_files(repository.inventories)
         self.revisions.add_fallback_versioned_files(repository.revisions)
         self.signatures.add_fallback_versioned_files(repository.signatures)
+        if self.chk_bytes is not None:
+            self.chk_bytes.add_fallback_versioned_files(repository.chk_bytes)
 
     def _check_fallback_repository(self, repository):
         """Check that this repository can fallback to repository safely.
@@ -993,12 +1006,21 @@
                 % (inv.revision_id, revision_id))
         if inv.root is None:
             raise AssertionError()
+        return self._add_inventory_checked(revision_id, inv, parents)
+
+    def _add_inventory_checked(self, revision_id, inv, parents):
+        """Add inv to the repository after checking the inputs.
+
+        This function can be overridden to allow different inventory styles.
+
+        :seealso: add_inventory, for the contract.
+        """
         inv_lines = self._serialise_inventory_to_lines(inv)
         return self._inventory_add_lines(revision_id, parents,
             inv_lines, check_content=False)
 
     def add_inventory_by_delta(self, basis_revision_id, delta, new_revision_id,
-                               parents):
+                               parents, basis_inv=None, propagate_caches=False):
         """Add a new inventory expressed as a delta against another revision.
 
         :param basis_revision_id: The inventory id the delta was created
@@ -1012,6 +1034,10 @@
             for repositories that depend on the inventory graph for revision
             graph access, as well as for those that pun ancestry with delta
             compression.
+        :param basis_inv: The basis inventory if it is already known,
+            otherwise None.
+        :param propagate_caches: If True, the caches for this inventory are
+          copied to and updated for the result if possible.
 
         :returns: (validator, new_inv)
             The validator(which is a sha1 digest, though what is sha'd is
@@ -1028,7 +1054,8 @@
             # inventory implementations may support: A better idiom would be to
             # return a new inventory, but as there is no revision tree cache in
             # repository this is safe for now - RBC 20081013
-            basis_inv = basis_tree.inventory
+            if basis_inv is None:
+                basis_inv = basis_tree.inventory
             basis_inv.apply_delta(delta)
             basis_inv.revision_id = new_revision_id
             return (self.add_inventory(new_revision_id, basis_inv, parents),
@@ -1996,7 +2023,10 @@
                             except KeyError:
                                 inv = self.revision_tree(parent_id).inventory
                                 inventory_cache[parent_id] = inv
-                            parent_entry = inv._byid.get(text_key[0], None)
+                            try:
+                                parent_entry = inv[text_key[0]]
+                            except (KeyError, errors.NoSuchId):
+                                parent_entry = None
                             if parent_entry is not None:
                                 parent_text_key = (
                                     text_key[0], parent_entry.revision)
@@ -2027,6 +2057,13 @@
             versions).  knit-kind is one of 'file', 'inventory', 'signatures',
             'revisions'.  file-id is None unless knit-kind is 'file'.
         """
+        for result in self._find_file_keys_to_fetch(revision_ids, _files_pb):
+            yield result
+        del _files_pb
+        for result in self._find_non_file_keys_to_fetch(revision_ids):
+            yield result
+
+    def _find_file_keys_to_fetch(self, revision_ids, pb):
         # XXX: it's a bit weird to control the inventory weave caching in this
         # generator.  Ideally the caching would be done in fetch.py I think.  Or
         # maybe this generator should explicitly have the contract that it
@@ -2039,14 +2076,12 @@
         count = 0
         num_file_ids = len(file_ids)
         for file_id, altered_versions in file_ids.iteritems():
-            if _files_pb is not None:
-                _files_pb.update("fetch texts", count, num_file_ids)
+            if pb is not None:
+                pb.update("fetch texts", count, num_file_ids)
             count += 1
             yield ("file", file_id, altered_versions)
-        # We're done with the files_pb.  Note that it finished by the caller,
-        # just as it was created by the caller.
-        del _files_pb
 
+    def _find_non_file_keys_to_fetch(self, revision_ids):
         # inventory
         yield ("inventory", None, revision_ids)
 
@@ -2492,8 +2527,10 @@
     """
     repository.start_write_group()
     try:
+        inventory_cache = lru_cache.LRUCache(10)
         for n, (revision, revision_tree, signature) in enumerate(iterable):
-            _install_revision(repository, revision, revision_tree, signature)
+            _install_revision(repository, revision, revision_tree, signature,
+                inventory_cache)
             if pb is not None:
                 pb.update('Transferring revisions', n + 1, num_revisions)
     except:
@@ -2503,7 +2540,8 @@
         repository.commit_write_group()
 
 
-def _install_revision(repository, rev, revision_tree, signature):
+def _install_revision(repository, rev, revision_tree, signature,
+    inventory_cache):
     """Install all revision data into a repository."""
     present_parents = []
     parent_trees = {}
@@ -2546,7 +2584,19 @@
         repository.texts.add_lines(text_key, text_parents, lines)
     try:
         # install the inventory
-        repository.add_inventory(rev.revision_id, inv, present_parents)
+        if repository._format._commit_inv_deltas and len(rev.parent_ids):
+            # Cache this inventory
+            inventory_cache[rev.revision_id] = inv
+            try:
+                basis_inv = inventory_cache[rev.parent_ids[0]]
+            except KeyError:
+                repository.add_inventory(rev.revision_id, inv, present_parents)
+            else:
+                delta = inv._make_delta(basis_inv)
+                repository.add_inventory_by_delta(rev.parent_ids[0], delta,
+                    rev.revision_id, present_parents)
+        else:
+            repository.add_inventory(rev.revision_id, inv, present_parents)
     except errors.RevisionAlreadyPresent:
         pass
     if signature is not None:
@@ -2659,6 +2709,11 @@
     # Can this repository be given external locations to lookup additional
     # data. Set to True or False in derived classes.
     supports_external_lookups = None
+    # Does this format support CHK bytestring lookups. Set to True or False in
+    # derived classes.
+    supports_chks = None
+    # Should commit add an inventory, or an inventory delta to the repository.
+    _commit_inv_deltas = True
     # What order should fetch operations request streams in?
     # The default is unordered as that is the cheapest for an origin to
     # provide.
@@ -2932,12 +2987,7 @@
     )
 
 # Development formats.
-# 1.7->1.8 go below here
-format_registry.register_lazy(
-    "Bazaar development format 2 (needs bzr.dev from before 1.8)\n",
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatPackDevelopment2',
-    )
+# Obsolete but kept pending a CHK based subtree format.
 format_registry.register_lazy(
     ("Bazaar development format 2 with subtree support "
         "(needs bzr.dev from before 1.8)\n"),
@@ -2945,6 +2995,14 @@
     'RepositoryFormatPackDevelopment2Subtree',
     )
 
+# 1.14->1.16 go below here
+format_registry.register_lazy(
+    'Bazaar development format - group compression and chk inventory'
+        ' (needs bzr.dev from 1.14)\n',
+    'bzrlib.repofmt.groupcompress_repo',
+    'RepositoryFormatCHK1',
+    )
+
 
 class InterRepository(InterObject):
     """This class represents operations taking place between two repositories.
@@ -3313,14 +3371,21 @@
         We don't test for the stores being of specific types because that
         could lead to confusing results, and there is no need to be
         overly general.
+
+        InterPackRepo does not support CHK based repositories.
         """
         from bzrlib.repofmt.pack_repo import RepositoryFormatPack
+        from bzrlib.repofmt.groupcompress_repo import RepositoryFormatCHK1
         try:
             are_packs = (isinstance(source._format, RepositoryFormatPack) and
                 isinstance(target._format, RepositoryFormatPack))
+            not_packs = (isinstance(source._format, RepositoryFormatCHK1) or
+                isinstance(target._format, RepositoryFormatCHK1))
         except AttributeError:
             return False
-        return are_packs and InterRepository._same_model(source, target)
+        if not_packs or not are_packs:
+            return False
+        return InterRepository._same_model(source, target)
 
     @needs_write_lock
     def fetch(self, revision_id=None, pb=None, find_ghosts=False,
@@ -3432,7 +3497,7 @@
         return self.source.revision_ids_to_search_result(result_set)
 
 
-class InterDifferingSerializer(InterKnitRepo):
+class InterDifferingSerializer(InterRepository):
 
     @classmethod
     def _get_repo_format_to_test(self):
@@ -3441,12 +3506,13 @@
     @staticmethod
     def is_compatible(source, target):
         """Be compatible with Knit2 source and Knit3 target"""
-        if source.supports_rich_root() != target.supports_rich_root():
+        # This is redundant with format.check_conversion_target(), however that
+        # raises an exception, and we just want to say "False" as in we won't
+        # support converting between these formats.
+        if source.supports_rich_root() and not target.supports_rich_root():
             return False
-        # Ideally, we'd support fetching if the source had no tree references
-        # even if it supported them...
-        if (getattr(source, '_format.supports_tree_reference', False) and
-            not getattr(target, '_format.supports_tree_reference', False)):
+        if (source._format.supports_tree_reference
+            and not target._format.supports_tree_reference):
             return False
         return True
 
@@ -3469,6 +3535,40 @@
         deltas.sort()
         return deltas[0][1:]
 
+    def _get_parent_keys(self, root_key, parent_map):
+        """Get the parent keys for a given root id."""
+        root_id, rev_id = root_key
+        # Include direct parents of the revision, but only if they used
+        # the same root_id.
+        parent_keys = []
+        for parent_id in parent_map[rev_id]:
+            if parent_id == _mod_revision.NULL_REVISION:
+                continue
+            if parent_id not in self._revision_id_to_root_id:
+                # We probably didn't read this revision, go spend the
+                # extra effort to actually check
+                try:
+                    tree = self.source.revision_tree(parent_id)
+                except errors.NoSuchRevision:
+                    # Ghost, fill out _revision_id_to_root_id in case we
+                    # encounter this again.
+                    # But set parent_root_id to None since we don't really know
+                    parent_root_id = None
+                else:
+                    parent_root_id = tree.get_root_id()
+                self._revision_id_to_root_id[parent_id] = None
+            else:
+                parent_root_id = self._revision_id_to_root_id[parent_id]
+            if root_id == parent_root_id or parent_root_id is None:
+                parent_keys.append((root_id, parent_id))
+        return tuple(parent_keys)
+
+    def _new_root_data_stream(self, root_keys_to_create, parent_map):
+        for root_key in root_keys_to_create:
+            parent_keys = self._get_parent_keys(root_key, parent_map)
+            yield versionedfile.FulltextContentFactory(root_key,
+                parent_keys, None, '')
+
     def _fetch_batch(self, revision_ids, basis_id, cache):
         """Fetch across a few revisions.
 
@@ -3482,6 +3582,7 @@
         # Walk though all revisions; get inventory deltas, copy referenced
         # texts that delta references, insert the delta, revision and
         # signature.
+        root_keys_to_create = set()
         text_keys = set()
         pending_deltas = []
         pending_revisions = []
@@ -3491,13 +3592,23 @@
             parent_ids = parent_map.get(current_revision_id, ())
             basis_id, delta = self._get_delta_for_revision(tree, parent_ids,
                                                            basis_id, cache)
+            if self._converting_to_rich_root:
+                self._revision_id_to_root_id[current_revision_id] = \
+                    tree.get_root_id()
             # Find text entries that need to be copied
             for old_path, new_path, file_id, entry in delta:
                 if new_path is not None:
-                    if not (new_path or self.target.supports_rich_root()):
-                        # We don't copy the text for the root node unless the
-                        # target supports_rich_root.
-                        continue
+                    if not new_path:
+                        # This is the root
+                        if not self.target.supports_rich_root():
+                            # The target doesn't support rich root, so we don't
+                            # copy
+                            continue
+                        if self._converting_to_rich_root:
+                            # This can't be copied normally, we have to insert
+                            # it specially
+                            root_keys_to_create.add((file_id, entry.revision))
+                            continue
                     text_keys.add((file_id, entry.revision))
             revision = self.source.get_revision(current_revision_id)
             pending_deltas.append((basis_id, delta,
@@ -3508,6 +3619,10 @@
         # Copy file texts
         from_texts = self.source.texts
         to_texts = self.target.texts
+        if root_keys_to_create:
+            root_stream = self._new_root_data_stream(root_keys_to_create,
+                                                     parent_map)
+            to_texts.insert_record_stream(root_stream)
         to_texts.insert_record_stream(from_texts.get_record_stream(
             text_keys, self.target._format._fetch_order,
             not self.target._format._fetch_uses_deltas))
@@ -3560,12 +3675,24 @@
         """See InterRepository.fetch()."""
         if fetch_spec is not None:
             raise AssertionError("Not implemented yet...")
+        if (not self.source.supports_rich_root()
+            and self.target.supports_rich_root()):
+            self._converting_to_rich_root = True
+            self._revision_id_to_root_id = {}
+        else:
+            self._converting_to_rich_root = False
         revision_ids = self.target.search_missing_revision_ids(self.source,
             revision_id, find_ghosts=find_ghosts).get_keys()
         if not revision_ids:
             return 0, 0
         revision_ids = tsort.topo_sort(
             self.source.get_graph().get_parent_map(revision_ids))
+        if not revision_ids:
+            return 0, 0
+        # Walk though all revisions; get inventory deltas, copy referenced
+        # texts that delta references, insert the delta, revision and
+        # signature.
+        first_rev = self.source.get_revision(revision_ids[0])
         if pb is None:
             my_pb = ui.ui_factory.nested_progress_bar()
             pb = my_pb
@@ -3834,6 +3961,10 @@
                 else:
                     self._extract_and_insert_inventories(
                         substream, src_serializer)
+            elif substream_type == 'chk_bytes':
+                # XXX: This doesn't support conversions, as it assumes the
+                #      conversion was done in the fetch code.
+                self.target_repo.chk_bytes.insert_record_stream(substream)
             elif substream_type == 'revisions':
                 # This may fallback to extract-and-insert more often than
                 # required if the serializers are different only in terms of
@@ -3988,10 +4119,8 @@
                 # know for unselected inventories whether all their required
                 # texts are present in the other repository - it could be
                 # corrupt.
-                yield ('inventories', from_weave.get_record_stream(
-                    [(rev_id,) for rev_id in revs],
-                    self.inventory_fetch_order(),
-                    not self.delta_on_metadata()))
+                for info in self._get_inventory_stream(revs):
+                    yield info
             elif knit_kind == "signatures":
                 # Nothing to do here; this will be taken care of when
                 # _fetch_revision_texts happens.
@@ -4038,3 +4167,127 @@
         return (not self.from_repository._format.rich_root_data and
             self.to_format.rich_root_data)
 
+    def _get_inventory_stream(self, revision_ids):
+        from_format = self.from_repository._format
+        if (from_format.supports_chks and self.to_format.supports_chks
+            and (from_format._serializer == self.to_format._serializer)):
+            # Both sides support chks, and they use the same serializer, so it
+            # is safe to transmit the chk pages and inventory pages across
+            # as-is.
+            return self._get_chk_inventory_stream(revision_ids)
+        elif (not from_format.supports_chks):
+            # Source repository doesn't support chks. So we can transmit the
+            # inventories 'as-is' and either they are just accepted on the
+            # target, or the Sink will properly convert it.
+            return self._get_simple_inventory_stream(revision_ids)
+        else:
+            # XXX: Hack to make not-chk->chk fetch: copy the inventories as
+            #      inventories. Note that this should probably be done somehow
+            #      as part of bzrlib.repository.StreamSink. Except JAM couldn't
+            #      figure out how a non-chk repository could possibly handle
+            #      deserializing an inventory stream from a chk repo, as it
+            #      doesn't have a way to understand individual pages.
+            return self._get_convertable_inventory_stream(revision_ids)
+
+    def _get_simple_inventory_stream(self, revision_ids):
+        from_weave = self.from_repository.inventories
+        yield ('inventories', from_weave.get_record_stream(
+            [(rev_id,) for rev_id in revision_ids],
+            self.inventory_fetch_order(),
+            not self.delta_on_metadata()))
+
+    def _get_chk_inventory_stream(self, revision_ids):
+        """Fetch the inventory texts, along with the associated chk maps."""
+        # We want an inventory outside of the search set, so that we can filter
+        # out uninteresting chk pages. For now we use
+        # _find_revision_outside_set, but if we had a Search with cut_revs, we
+        # could use that instead.
+        start_rev_id = self.from_repository._find_revision_outside_set(
+                            revision_ids)
+        start_rev_key = (start_rev_id,)
+        inv_keys_to_fetch = [(rev_id,) for rev_id in revision_ids]
+        if start_rev_id != _mod_revision.NULL_REVISION:
+            inv_keys_to_fetch.append((start_rev_id,))
+        # Any repo that supports chk_bytes must also support out-of-order
+        # insertion. At least, that is how we expect it to work
+        # We use get_record_stream instead of iter_inventories because we want
+        # to be able to insert the stream as well. We could instead fetch
+        # allowing deltas, and then iter_inventories, but we don't know whether
+        # source or target is more 'local' anway.
+        inv_stream = self.from_repository.inventories.get_record_stream(
+            inv_keys_to_fetch, 'unordered',
+            True) # We need them as full-texts so we can find their references
+        uninteresting_chk_roots = set()
+        interesting_chk_roots = set()
+        def filter_inv_stream(inv_stream):
+            for idx, record in enumerate(inv_stream):
+                ### child_pb.update('fetch inv', idx, len(inv_keys_to_fetch))
+                bytes = record.get_bytes_as('fulltext')
+                chk_inv = inventory.CHKInventory.deserialise(
+                    self.from_repository.chk_bytes, bytes, record.key)
+                if record.key == start_rev_key:
+                    uninteresting_chk_roots.add(chk_inv.id_to_entry.key())
+                    p_id_map = chk_inv.parent_id_basename_to_file_id
+                    if p_id_map is not None:
+                        uninteresting_chk_roots.add(p_id_map.key())
+                else:
+                    yield record
+                    interesting_chk_roots.add(chk_inv.id_to_entry.key())
+                    p_id_map = chk_inv.parent_id_basename_to_file_id
+                    if p_id_map is not None:
+                        interesting_chk_roots.add(p_id_map.key())
+        ### pb.update('fetch inventory', 0, 2)
+        yield ('inventories', filter_inv_stream(inv_stream))
+        # Now that we have worked out all of the interesting root nodes, grab
+        # all of the interesting pages and insert them
+        ### pb.update('fetch inventory', 1, 2)
+        interesting = chk_map.iter_interesting_nodes(
+            self.from_repository.chk_bytes, interesting_chk_roots,
+            uninteresting_chk_roots)
+        def to_stream_adapter():
+            """Adapt the iter_interesting_nodes result to a single stream.
+
+            iter_interesting_nodes returns records as it processes them, along
+            with keys. However, we only want to return the records themselves.
+            """
+            for record, items in interesting:
+                if record is not None:
+                    yield record
+        # XXX: We could instead call get_record_stream(records.keys())
+        #      ATM, this will always insert the records as fulltexts, and
+        #      requires that you can hang on to records once you have gone
+        #      on to the next one. Further, it causes the target to
+        #      recompress the data. Testing shows it to be faster than
+        #      requesting the records again, though.
+        yield ('chk_bytes', to_stream_adapter())
+        ### pb.update('fetch inventory', 2, 2)
+
+    def _get_convertable_inventory_stream(self, revision_ids):
+        # XXX: One of source or target is using chks, and they don't have
+        #      compatible serializations. The StreamSink code expects to be
+        #      able to convert on the target, so we need to put
+        #      bytes-on-the-wire that can be converted
+        yield ('inventories', self._stream_invs_as_fulltexts(revision_ids))
+
+    def _stream_invs_as_fulltexts(self, revision_ids):
+        from_repo = self.from_repository
+        from_serializer = from_repo._format._serializer
+        revision_keys = [(rev_id,) for rev_id in revision_ids]
+        parent_map = from_repo.inventories.get_parent_map(revision_keys)
+        for inv in self.from_repository.iter_inventories(revision_ids):
+            # XXX: This is a bit hackish, but it works. Basically,
+            #      CHKSerializer 'accidentally' supports
+            #      read/write_inventory_to_string, even though that is never
+            #      the format that is stored on disk. It *does* give us a
+            #      single string representation for an inventory, so live with
+            #      it for now.
+            #      This would be far better if we had a 'serialized inventory
+            #      delta' form. Then we could use 'inventory._make_delta', and
+            #      transmit that. This would both be faster to generate, and
+            #      result in fewer bytes-on-the-wire.
+            as_bytes = from_serializer.write_inventory_to_string(inv)
+            key = (inv.revision_id,)
+            parent_keys = parent_map.get(key, ())
+            yield versionedfile.FulltextContentFactory(
+                key, parent_keys, None, as_bytes)
+

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2009-04-07 13:08:21 +0000
+++ bzrlib/tests/__init__.py	2009-04-07 13:56:43 +0000
@@ -3270,6 +3270,7 @@
                    'bzrlib.tests.per_interbranch',
                    'bzrlib.tests.per_lock',
                    'bzrlib.tests.per_repository',
+                   'bzrlib.tests.per_repository_chk',
                    'bzrlib.tests.per_repository_reference',
                    'bzrlib.tests.test__chk_map',
                    'bzrlib.tests.test__dirstate_helpers',
@@ -3289,10 +3290,7 @@
                    'bzrlib.tests.test_bzrdir',
                    'bzrlib.tests.test__chunks_to_lines',
                    'bzrlib.tests.test_cache_utf8',
-                   # These need to be excluded until the development5 format
-                   # lands. (That's waiting on the dependent inventory and
-                   # repository changes to land.)
-                   #'bzrlib.tests.test_chk_map',
+                   'bzrlib.tests.test_chk_map',
                    'bzrlib.tests.test_chunk_writer',
                    'bzrlib.tests.test_clean_tree',
                    'bzrlib.tests.test_commands',

=== modified file 'bzrlib/tests/blackbox/test_add.py'
--- bzrlib/tests/blackbox/test_add.py	2009-03-31 14:12:27 +0000
+++ bzrlib/tests/blackbox/test_add.py	2009-04-07 12:32:42 +0000
@@ -34,7 +34,7 @@
         standard_tests, condition_isinstance(TestAdd))
     scenarios = [
         ('pre-views', {'branch_tree_format': 'pack-0.92'}),
-        ('view-aware', {'branch_tree_format': 'development-wt6'}),
+        ('view-aware', {'branch_tree_format': 'development6-rich-root'}),
         ]
     return multiply_tests(to_adapt, scenarios, result)
 

=== modified file 'bzrlib/tests/blackbox/test_branch.py'
--- bzrlib/tests/blackbox/test_branch.py	2009-04-03 01:05:08 +0000
+++ bzrlib/tests/blackbox/test_branch.py	2009-04-07 12:32:42 +0000
@@ -159,11 +159,11 @@
         """Branching a stacked branch is not stacked by default"""
         # We have a mainline
         trunk_tree = self.make_branch_and_tree('target',
-            format='development')
+            format='1.9')
         trunk_tree.commit('mainline')
         # and a branch from it which is stacked
         branch_tree = self.make_branch_and_tree('branch',
-            format='development')
+            format='1.9')
         branch_tree.branch.set_stacked_on_url(trunk_tree.branch.base)
         # with some work on it
         branch_tree.commit('moar work plz')
@@ -183,11 +183,11 @@
         """Asking to stack on a stacked branch does work"""
         # We have a mainline
         trunk_tree = self.make_branch_and_tree('target',
-            format='development')
+            format='1.9')
         trunk_revid = trunk_tree.commit('mainline')
         # and a branch from it which is stacked
         branch_tree = self.make_branch_and_tree('branch',
-            format='development')
+            format='1.9')
         branch_tree.branch.set_stacked_on_url(trunk_tree.branch.base)
         # with some work on it
         branch_revid = branch_tree.commit('moar work plz')
@@ -208,7 +208,7 @@
     def test_branch_stacked(self):
         # We have a mainline
         trunk_tree = self.make_branch_and_tree('mainline',
-            format='development')
+            format='1.9')
         original_revid = trunk_tree.commit('mainline')
         self.assertRevisionInRepository('mainline', original_revid)
         # and a branch from it which is stacked
@@ -226,7 +226,7 @@
         # We can branch stacking on a smart server
         from bzrlib.smart.server import SmartTCPServer_for_testing
         self.transport_server = SmartTCPServer_for_testing
-        trunk = self.make_branch('mainline', format='development')
+        trunk = self.make_branch('mainline', format='1.9')
         out, err = self.run_bzr(
             ['branch', '--stacked', self.get_url('mainline'), 'shallow'])
 

=== modified file 'bzrlib/tests/blackbox/test_filtered_view_ops.py'
--- bzrlib/tests/blackbox/test_filtered_view_ops.py	2009-03-31 14:13:27 +0000
+++ bzrlib/tests/blackbox/test_filtered_view_ops.py	2009-04-07 12:32:42 +0000
@@ -28,7 +28,7 @@
     def make_abc_tree_with_ab_view(self):
         # we need to use a specific format because the default format
         # doesn't support views yet
-        format = bzrdir.format_registry.make_bzrdir('development-wt6')
+        format = bzrdir.format_registry.make_bzrdir('development6-rich-root')
         wt = TestCaseWithTransport.make_branch_and_tree(self, '.',
             format=format)
         self.build_tree(['a', 'b', 'c'])
@@ -157,7 +157,7 @@
     def make_abc_tree_and_clone_with_ab_view(self):
         # we need to use a specific format because the default format
         # doesn't support views yet
-        format = bzrdir.format_registry.make_bzrdir('development-wt6')
+        format = bzrdir.format_registry.make_bzrdir('development6-rich-root')
         # Build the first tree
         wt1 = TestCaseWithTransport.make_branch_and_tree(self, 'tree_1',
             format=format)

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2009-04-03 19:03:38 +0000
+++ bzrlib/tests/blackbox/test_push.py	2009-04-07 12:32:42 +0000
@@ -312,11 +312,11 @@
     def create_trunk_and_feature_branch(self):
         # We have a mainline
         trunk_tree = self.make_branch_and_tree('target',
-            format='development')
+            format='1.9')
         trunk_tree.commit('mainline')
         # and a branch from it
         branch_tree = self.make_branch_and_tree('branch',
-            format='development')
+            format='1.9')
         branch_tree.pull(trunk_tree.branch)
         branch_tree.branch.set_parent(trunk_tree.branch.base)
         # with some work on it
@@ -360,7 +360,7 @@
         trunk_tree, branch_tree = self.create_trunk_and_feature_branch()
         # the trunk is published on a web server
         self.transport_readonly_server = HttpServer
-        trunk_public = self.make_branch('public_trunk', format='development')
+        trunk_public = self.make_branch('public_trunk', format='1.9')
         trunk_public.pull(trunk_tree.branch)
         trunk_public_url = self.get_readonly_url('public_trunk')
         trunk_tree.branch.set_public_branch(trunk_public_url)
@@ -375,7 +375,7 @@
 
     def test_push_new_branch_stacked_no_parent(self):
         """Pushing with --stacked and no parent branch errors."""
-        branch = self.make_branch_and_tree('branch', format='development')
+        branch = self.make_branch_and_tree('branch', format='1.9')
         # now we do a stacked push, which should fail as the place to refer too
         # cannot be determined.
         out, err = self.run_bzr_error(

=== modified file 'bzrlib/tests/blackbox/test_view.py'
--- bzrlib/tests/blackbox/test_view.py	2009-03-31 14:12:27 +0000
+++ bzrlib/tests/blackbox/test_view.py	2009-04-07 12:32:42 +0000
@@ -26,7 +26,7 @@
     def make_branch_and_tree(self):
         # we need to use a specific format because the default format
         # doesn't support views yet
-        format = bzrdir.format_registry.make_bzrdir('development-wt6')
+        format = bzrdir.format_registry.make_bzrdir('development6-rich-root')
         return TestCaseWithTransport.make_branch_and_tree(self, '.',
             format=format)
 

=== modified file 'bzrlib/tests/intertree_implementations/__init__.py'
--- bzrlib/tests/intertree_implementations/__init__.py	2009-04-07 07:20:17 +0000
+++ bzrlib/tests/intertree_implementations/__init__.py	2009-04-07 12:32:42 +0000
@@ -138,7 +138,8 @@
             # -- vila 20090311
             chk_tree_format = WorkingTreeFormat4()
             chk_tree_format._get_matchingbzrdir = \
-                lambda:bzrlib.bzrdir.format_registry.make_bzrdir('development')
+                lambda:bzrlib.bzrdir.format_registry.make_bzrdir(
+                    'development6-rich-root')
             test_intertree_permutations.append(
                 (InterTree.__name__ + "(CHKInventory)",
                  InterTree,

=== modified file 'bzrlib/tests/per_repository/test_repository.py'
--- bzrlib/tests/per_repository/test_repository.py	2009-04-06 02:20:10 +0000
+++ bzrlib/tests/per_repository/test_repository.py	2009-04-07 12:32:42 +0000
@@ -31,7 +31,7 @@
     )
 from bzrlib.branch import BzrBranchFormat6
 from bzrlib.delta import TreeDelta
-from bzrlib.inventory import Inventory, InventoryDirectory
+from bzrlib.inventory import CommonInventory, Inventory, InventoryDirectory
 from bzrlib.repofmt.weaverepo import (
     RepositoryFormat5,
     RepositoryFormat6,
@@ -249,7 +249,7 @@
         invs = tree.branch.repository.iter_inventories(revs)
         for rev_id, inv in zip(revs, invs):
             self.assertEqual(rev_id, inv.revision_id)
-            self.assertIsInstance(inv, Inventory)
+            self.assertIsInstance(inv, CommonInventory)
 
     def test_supports_rich_root(self):
         tree = self.make_branch_and_tree('a')

=== added directory 'bzrlib/tests/per_repository_chk'
=== added file 'bzrlib/tests/per_repository_chk/__init__.py'
--- bzrlib/tests/per_repository_chk/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/per_repository_chk/__init__.py	2009-04-07 12:32:42 +0000
@@ -0,0 +1,82 @@
+# Copyright (C) 2008, 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+"""Repository implementation tests for CHK support.
+
+These tests check the conformance of the chk index some repositories support.
+All repository formats are tested - those that do not suppport chk indices
+have the test_unsupported tests run; the others have the test_supported tests
+run.
+"""
+
+from bzrlib import (
+    repository,
+    remote,
+    )
+from bzrlib.bzrdir import BzrDir
+from bzrlib.repofmt.pack_repo import (
+    RepositoryFormatKnitPack5,
+    )
+from bzrlib.repofmt.groupcompress_repo import (
+    RepositoryFormatCHK1,
+    )
+from bzrlib.tests import (
+    multiply_tests,
+    TestSuite,
+    )
+from bzrlib.tests.per_repository import (
+    all_repository_format_scenarios,
+    TestCaseWithRepository,
+    )
+
+
+class TestCaseWithRepositoryCHK(TestCaseWithRepository):
+
+    def make_repository(self, path):
+        TestCaseWithRepository.make_repository(self, path)
+        return repository.Repository.open(self.get_transport(path).base)
+
+
+def load_tests(standard_tests, module, loader):
+    supported_scenarios = []
+    unsupported_scenarios = []
+    for test_name, scenario_info in all_repository_format_scenarios():
+        format = scenario_info['repository_format']
+        # For remote repositories, we test both with, and without a backing chk
+        # capable format: change the format we use to create the repo to direct
+        # formats, and then the overridden make_repository in
+        # TestCaseWithRepositoryCHK will give a re-opened RemoteRepository
+        # with the chosen backing format.
+        if isinstance(format, remote.RemoteRepositoryFormat):
+            with_support = dict(scenario_info)
+            with_support['repository_format'] = RepositoryFormatCHK1()
+            supported_scenarios.append((test_name + "(Supported)", with_support))
+            no_support = dict(scenario_info)
+            no_support['repository_format'] = RepositoryFormatKnitPack5()
+            unsupported_scenarios.append((test_name + "(Not Supported)", no_support))
+        elif format.supports_chks:
+            supported_scenarios.append((test_name, scenario_info))
+        else:
+            unsupported_scenarios.append((test_name, scenario_info))
+    result = loader.suiteClass()
+    supported_tests = loader.loadTestsFromModuleNames([
+        'bzrlib.tests.per_repository_chk.test_supported'])
+    unsupported_tests = loader.loadTestsFromModuleNames([
+        'bzrlib.tests.per_repository_chk.test_unsupported'])
+    multiply_tests(supported_tests, supported_scenarios, result)
+    multiply_tests(unsupported_tests, unsupported_scenarios, result)
+    return result

=== added file 'bzrlib/tests/per_repository_chk/test_supported.py'
--- bzrlib/tests/per_repository_chk/test_supported.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/per_repository_chk/test_supported.py	2009-04-07 12:32:42 +0000
@@ -0,0 +1,106 @@
+# Copyright (C) 2008 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for repositories that support CHK indices."""
+
+from bzrlib import osutils
+from bzrlib.versionedfile import VersionedFiles
+from bzrlib.tests.per_repository_chk import TestCaseWithRepositoryCHK
+
+
+class TestCHKSupport(TestCaseWithRepositoryCHK):
+
+    def test_chk_bytes_attribute_is_VersionedFiles(self):
+        repo = self.make_repository('.')
+        self.assertIsInstance(repo.chk_bytes, VersionedFiles)
+
+    def test_add_bytes_to_chk_bytes_store(self):
+        repo = self.make_repository('.')
+        repo.lock_write()
+        try:
+            repo.start_write_group()
+            try:
+                sha1, len, _ = repo.chk_bytes.add_lines((None,),
+                    None, ["foo\n", "bar\n"], random_id=True)
+                self.assertEqual('4e48e2c9a3d2ca8a708cb0cc545700544efb5021',
+                    sha1)
+                self.assertEqual(
+                    set([('sha1:4e48e2c9a3d2ca8a708cb0cc545700544efb5021',)]),
+                    repo.chk_bytes.keys())
+            except:
+                repo.abort_write_group()
+                raise
+            else:
+                repo.commit_write_group()
+        finally:
+            repo.unlock()
+        # And after an unlock/lock pair
+        repo.lock_read()
+        try:
+            self.assertEqual(
+                set([('sha1:4e48e2c9a3d2ca8a708cb0cc545700544efb5021',)]),
+                repo.chk_bytes.keys())
+        finally:
+            repo.unlock()
+        # and reopening
+        repo = repo.bzrdir.open_repository()
+        repo.lock_read()
+        try:
+            self.assertEqual(
+                set([('sha1:4e48e2c9a3d2ca8a708cb0cc545700544efb5021',)]),
+                repo.chk_bytes.keys())
+        finally:
+            repo.unlock()
+
+    def test_pack_preserves_chk_bytes_store(self):
+        leaf_lines = ["chkleaf:\n", "0\n", "1\n", "0\n", "\n"]
+        leaf_sha1 = osutils.sha_strings(leaf_lines)
+        node_lines = ["chknode:\n", "0\n", "1\n", "1\n", "foo\n",
+                      "\x00sha1:%s\n" % (leaf_sha1,)]
+        node_sha1 = osutils.sha_strings(node_lines)
+        expected_set = set([('sha1:' + leaf_sha1,), ('sha1:' + node_sha1,)])
+        repo = self.make_repository('.')
+        repo.lock_write()
+        try:
+            repo.start_write_group()
+            try:
+                # Internal node pointing at a leaf.
+                repo.chk_bytes.add_lines((None,), None, node_lines, random_id=True)
+            except:
+                repo.abort_write_group()
+                raise
+            else:
+                repo.commit_write_group()
+            repo.start_write_group()
+            try:
+                # Leaf in a separate pack.
+                repo.chk_bytes.add_lines((None,), None, leaf_lines, random_id=True)
+            except:
+                repo.abort_write_group()
+                raise
+            else:
+                repo.commit_write_group()
+            repo.pack()
+            self.assertEqual(expected_set, repo.chk_bytes.keys())
+        finally:
+            repo.unlock()
+        # and reopening
+        repo = repo.bzrdir.open_repository()
+        repo.lock_read()
+        try:
+            self.assertEqual(expected_set, repo.chk_bytes.keys())
+        finally:
+            repo.unlock()

=== added file 'bzrlib/tests/per_repository_chk/test_unsupported.py'
--- bzrlib/tests/per_repository_chk/test_unsupported.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/per_repository_chk/test_unsupported.py	2009-04-07 12:32:42 +0000
@@ -0,0 +1,30 @@
+# Copyright (C) 2008 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for repositories that do not support CHK indices.
+
+CHK support is optional, and when it is not supported the methods and
+attributes CHK support added should fail in known ways.
+"""
+
+from bzrlib.tests.per_repository_chk import TestCaseWithRepositoryCHK
+
+
+class TestNoCHKSupport(TestCaseWithRepositoryCHK):
+
+    def test_chk_bytes_attribute_is_None(self):
+        repo = self.make_repository('.')
+        self.assertEqual(None, repo.chk_bytes)

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2009-03-24 06:40:26 +0000
+++ bzrlib/tests/test_branch.py	2009-04-07 12:32:42 +0000
@@ -334,7 +334,7 @@
         return _mod_branch.BzrBranch7
 
     def get_format_name(self):
-        return "development"
+        return "1.9"
 
     def get_format_name_subtree(self):
         return "development-subtree"

=== modified file 'bzrlib/tests/test_chk_map.py'
--- bzrlib/tests/test_chk_map.py	2009-04-03 02:29:30 +0000
+++ bzrlib/tests/test_chk_map.py	2009-04-07 12:32:42 +0000
@@ -57,9 +57,9 @@
 class TestCaseWithStore(tests.TestCaseWithTransport):
 
     def get_chk_bytes(self):
-        # The easiest way to get a CHK store is a development5 repository and
+        # The easiest way to get a CHK store is a development6 repository and
         # then work with the chk_bytes attribute directly.
-        repo = self.make_repository(".", format="development5")
+        repo = self.make_repository(".", format="development6-rich-root")
         repo.lock_write()
         self.addCleanup(repo.unlock)
         repo.start_write_group()

=== modified file 'bzrlib/tests/test_inv.py'
--- bzrlib/tests/test_inv.py	2009-04-07 04:21:55 +0000
+++ bzrlib/tests/test_inv.py	2009-04-07 12:32:42 +0000
@@ -171,11 +171,9 @@
 class TestCHKInventory(TestCaseWithTransport):
 
     def get_chk_bytes(self):
-        # The easiest way to get a CHK store is a development5 repository and
+        # The easiest way to get a CHK store is a development6 repository and
         # then work with the chk_bytes attribute directly.
-        from bzrlib.tests import TestSkipped
-        raise TestSkipped("Cannot execut CHKInventory tests yet.")
-        repo = self.make_repository(".", format="development5")
+        repo = self.make_repository(".", format="development6-rich-root")
         repo.lock_write()
         self.addCleanup(repo.unlock)
         repo.start_write_group()

=== modified file 'bzrlib/tests/test_pack_repository.py'
--- bzrlib/tests/test_pack_repository.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_pack_repository.py	2009-04-07 12:32:42 +0000
@@ -38,6 +38,7 @@
     upgrade,
     workingtree,
     )
+from bzrlib.repofmt.groupcompress_repo import RepositoryFormatCHK1
 from bzrlib.smart import (
     client,
     server,
@@ -208,11 +209,14 @@
         tree = tree.bzrdir.open_workingtree()
         check_result = tree.branch.repository.check(
             [tree.branch.last_revision()])
-        # We should have 50 (10x5) files in the obsolete_packs directory.
+        nb_files = 5 # .pack, .rix, .iix, .tix, .six
+        if tree.branch.repository._format.supports_chks:
+            nb_files += 1 # .cix
+        # We should have 10 x nb_files files in the obsolete_packs directory.
         obsolete_files = list(trans.list_dir('obsolete_packs'))
         self.assertFalse('foo' in obsolete_files)
         self.assertFalse('bar' in obsolete_files)
-        self.assertEqual(50, len(obsolete_files))
+        self.assertEqual(10 * nb_files, len(obsolete_files))
         # XXX: Todo check packs obsoleted correctly - old packs and indices
         # in the obsolete_packs directory.
         large_pack_name = list(index.iter_all_entries())[0][1][0]
@@ -252,7 +256,11 @@
         self.assertEqual(2, len(tree.branch.repository.all_revision_ids()))
 
     def test_pack_layout(self):
+        # Test that the ordering of revisions in pack repositories is
+        # tip->ancestor
         format = self.get_format()
+        if type(format.repository_format) is RepositoryFormatCHK1:
+            raise TestSkipped("Not updated for GroupCompress internals")
         tree = self.make_branch_and_tree('.', format=format)
         trans = tree.branch.repository.bzrdir.get_repository_transport(None)
         tree.commit('start', rev_id='1')
@@ -283,7 +291,8 @@
 
     def _add_text(self, repo, fileid):
         """Add a text to the repository within a write group."""
-        repo.texts.add_lines((fileid, 'samplerev+'+fileid), [], [])
+        repo.texts.add_lines((fileid, 'samplerev+'+fileid), [],
+            ['smaplerev+'+fileid])
 
     def test_concurrent_writers_merge_new_packs(self):
         format = self.get_format()
@@ -543,6 +552,9 @@
     def test_missing_inventories_compression_parent_prevents_commit(self):
         repo = self.make_write_ready_repo()
         key = ('junk',)
+        if not getattr(repo.inventories._index, '_missing_compression_parents',
+            None):
+            raise TestSkipped("No missing compression parents")
         repo.inventories._index._missing_compression_parents.add(key)
         self.assertRaises(errors.BzrCheckError, repo.commit_write_group)
         self.assertRaises(errors.BzrCheckError, repo.commit_write_group)
@@ -552,6 +564,9 @@
     def test_missing_revisions_compression_parent_prevents_commit(self):
         repo = self.make_write_ready_repo()
         key = ('junk',)
+        if not getattr(repo.inventories._index, '_missing_compression_parents',
+            None):
+            raise TestSkipped("No missing compression parents")
         repo.revisions._index._missing_compression_parents.add(key)
         self.assertRaises(errors.BzrCheckError, repo.commit_write_group)
         self.assertRaises(errors.BzrCheckError, repo.commit_write_group)
@@ -561,6 +576,9 @@
     def test_missing_signatures_compression_parent_prevents_commit(self):
         repo = self.make_write_ready_repo()
         key = ('junk',)
+        if not getattr(repo.inventories._index, '_missing_compression_parents',
+            None):
+            raise TestSkipped("No missing compression parents")
         repo.signatures._index._missing_compression_parents.add(key)
         self.assertRaises(errors.BzrCheckError, repo.commit_write_group)
         self.assertRaises(errors.BzrCheckError, repo.commit_write_group)
@@ -570,6 +588,9 @@
     def test_missing_text_compression_parent_prevents_commit(self):
         repo = self.make_write_ready_repo()
         key = ('some', 'junk')
+        if not getattr(repo.inventories._index, '_missing_compression_parents',
+            None):
+            raise TestSkipped("No missing compression parents")
         repo.texts._index._missing_compression_parents.add(key)
         self.assertRaises(errors.BzrCheckError, repo.commit_write_group)
         e = self.assertRaises(errors.BzrCheckError, repo.commit_write_group)
@@ -699,12 +720,19 @@
             # can only stack on repositories that have compatible internal
             # metadata
             if getattr(repo._format, 'supports_tree_reference', False):
-                matching_format_name = 'pack-0.92-subtree'
+                if repo._format.supports_chks:
+                    matching_format_name = 'development6-rich-root'
+                else:
+                    matching_format_name = 'pack-0.92-subtree'
             else:
                 matching_format_name = 'rich-root-pack'
             mismatching_format_name = 'pack-0.92'
         else:
-            matching_format_name = 'pack-0.92'
+            # We don't have a non-rich-root CHK format.
+            if repo._format.supports_chks:
+                raise AssertionError("no non-rich-root CHK formats known")
+            else:
+                matching_format_name = 'pack-0.92'
             mismatching_format_name = 'pack-0.92-subtree'
         base = self.make_repository('base', format=matching_format_name)
         repo.add_fallback_repository(base)
@@ -715,7 +743,7 @@
             repo.add_fallback_repository, bad_repo)
         self.assertContainsRe(str(e),
             r'(?m)KnitPackRepository.*/mismatch/.*\nis not compatible with\n'
-            r'KnitPackRepository.*/repo/.*\n'
+            r'.*Repository.*/repo/.*\n'
             r'different rich-root support')
 
     def test_stack_checks_serializers_compatibility(self):
@@ -723,7 +751,11 @@
         if getattr(repo._format, 'supports_tree_reference', False):
             # can only stack on repositories that have compatible internal
             # metadata
-            matching_format_name = 'pack-0.92-subtree'
+            if repo._format.supports_chks:
+                # No CHK subtree formats in bzr.dev, so this doesn't execute.
+                matching_format_name = 'development6-subtree'
+            else:
+                matching_format_name = 'pack-0.92-subtree'
             mismatching_format_name = 'rich-root-pack'
         else:
             if repo.supports_rich_root():
@@ -741,7 +773,7 @@
             repo.add_fallback_repository, bad_repo)
         self.assertContainsRe(str(e),
             r'(?m)KnitPackRepository.*/mismatch/.*\nis not compatible with\n'
-            r'KnitPackRepository.*/repo/.*\n'
+            r'.*Repository.*/repo/.*\n'
             r'different serializers')
 
     def test_adding_pack_does_not_record_pack_names_from_other_repositories(self):
@@ -757,9 +789,10 @@
         self.assertEqual(1, len(new_instance._pack_collection.all_packs()))
 
     def test_autopack_only_considers_main_repo_packs(self):
-        base = self.make_branch_and_tree('base', format=self.get_format())
+        format = self.get_format()
+        base = self.make_branch_and_tree('base', format=format)
         base.commit('foo')
-        tree = self.make_branch_and_tree('repo', format=self.get_format())
+        tree = self.make_branch_and_tree('repo', format=format)
         tree.branch.repository.add_fallback_repository(base.branch.repository)
         trans = tree.branch.repository.bzrdir.get_repository_transport(None)
         # This test could be a little cheaper by replacing the packs
@@ -780,11 +813,14 @@
         tree = tree.bzrdir.open_workingtree()
         check_result = tree.branch.repository.check(
             [tree.branch.last_revision()])
-        # We should have 50 (10x5) files in the obsolete_packs directory.
+        nb_files = 5 # .pack, .rix, .iix, .tix, .six
+        if tree.branch.repository._format.supports_chks:
+            nb_files += 1 # .cix
+        # We should have 10 x nb_files files in the obsolete_packs directory.
         obsolete_files = list(trans.list_dir('obsolete_packs'))
         self.assertFalse('foo' in obsolete_files)
         self.assertFalse('bar' in obsolete_files)
-        self.assertEqual(50, len(obsolete_files))
+        self.assertEqual(10 * nb_files, len(obsolete_files))
         # XXX: Todo check packs obsoleted correctly - old packs and indices
         # in the obsolete_packs directory.
         large_pack_name = list(index.iter_all_entries())[0][1][0]
@@ -818,8 +854,9 @@
 
     def test_autopack_or_streaming_rpc_is_used_when_using_hpss(self):
         # Make local and remote repos
-        tree = self.make_branch_and_tree('local', format=self.get_format())
-        self.make_branch_and_tree('remote', format=self.get_format())
+        format = self.get_format()
+        tree = self.make_branch_and_tree('local', format=format)
+        self.make_branch_and_tree('remote', format=format)
         remote_branch_url = self.smart_server.get_url() + 'remote'
         remote_branch = bzrdir.BzrDir.open(remote_branch_url).open_branch()
         # Make 9 local revisions, and push them one at a time to the remote
@@ -879,15 +916,10 @@
                   "(bzr 1.9)\n",
               format_supports_external_lookups=True,
               index_class=BTreeGraphIndex),
-         dict(format_name='development2',
-              format_string="Bazaar development format 2 "
-                  "(needs bzr.dev from before 1.8)\n",
-              format_supports_external_lookups=True,
-              index_class=BTreeGraphIndex),
-         dict(format_name='development2-subtree',
-              format_string="Bazaar development format 2 "
-                  "with subtree support (needs bzr.dev from before 1.8)\n",
-              format_supports_external_lookups=True,
+         dict(format_name='development6-rich-root',
+              format_string='Bazaar development format - group compression '
+                  'and chk inventory (needs bzr.dev from 1.14)\n',
+              format_supports_external_lookups=False,
               index_class=BTreeGraphIndex),
          ]
     # name of the scenario is the format name

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2009-04-03 01:21:06 +0000
+++ bzrlib/tests/test_remote.py	2009-04-07 12:32:42 +0000
@@ -49,7 +49,7 @@
     RemoteRepository,
     RemoteRepositoryFormat,
     )
-from bzrlib.repofmt import pack_repo
+from bzrlib.repofmt import groupcompress_repo, pack_repo
 from bzrlib.revision import NULL_REVISION
 from bzrlib.smart import server, medium
 from bzrlib.smart.client import _SmartClient
@@ -1517,7 +1517,7 @@
 class TestRepositoryFormat(TestRemoteRepository):
 
     def test_fast_delta(self):
-        true_name = pack_repo.RepositoryFormatPackDevelopment2().network_name()
+        true_name = groupcompress_repo.RepositoryFormatCHK1().network_name()
         true_format = RemoteRepositoryFormat()
         true_format._network_name = true_name
         self.assertEqual(True, true_format.fast_deltas)

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_repository.py	2009-04-07 12:32:42 +0000
@@ -32,6 +32,7 @@
                            UnsupportedFormatError,
                            )
 from bzrlib import graph
+from bzrlib.branchbuilder import BranchBuilder
 from bzrlib.btree_index import BTreeBuilder, BTreeGraphIndex
 from bzrlib.index import GraphIndex, InMemoryGraphIndex
 from bzrlib.repository import RepositoryFormat
@@ -60,7 +61,12 @@
     upgrade,
     workingtree,
     )
-from bzrlib.repofmt import knitrepo, weaverepo, pack_repo
+from bzrlib.repofmt import (
+    groupcompress_repo,
+    knitrepo,
+    pack_repo,
+    weaverepo,
+    )
 
 
 class TestDefaultFormat(TestCase):
@@ -664,6 +670,81 @@
         self.assertFalse(repo._format.supports_external_lookups)
 
 
+class TestDevelopment6(TestCaseWithTransport):
+
+    def test_inventories_use_chk_map_with_parent_base_dict(self):
+        tree = self.make_branch_and_tree('repo', format="development6-rich-root")
+        revid = tree.commit("foo")
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+        inv = tree.branch.repository.get_inventory(revid)
+        self.assertNotEqual(None, inv.parent_id_basename_to_file_id)
+        inv.parent_id_basename_to_file_id._ensure_root()
+        inv.id_to_entry._ensure_root()
+        self.assertEqual(65536, inv.id_to_entry._root_node.maximum_size)
+        self.assertEqual(65536,
+            inv.parent_id_basename_to_file_id._root_node.maximum_size)
+
+
+class TestDevelopment6FindRevisionOutsideSet(TestCaseWithTransport):
+    """Tests for _find_revision_outside_set."""
+
+    def setUp(self):
+        super(TestDevelopment6FindRevisionOutsideSet, self).setUp()
+        self.builder = self.make_branch_builder('source',
+            format='development6-rich-root')
+        self.builder.start_series()
+        self.builder.build_snapshot('initial', None,
+            [('add', ('', 'tree-root', 'directory', None))])
+        self.repo = self.builder.get_branch().repository
+        self.addCleanup(self.builder.finish_series)
+
+    def assertRevisionOutsideSet(self, expected_result, rev_set):
+        self.assertEqual(
+            expected_result, self.repo._find_revision_outside_set(rev_set))
+
+    def test_simple(self):
+        self.builder.build_snapshot('revid1', None, [])
+        self.builder.build_snapshot('revid2', None, [])
+        rev_set = ['revid2']
+        self.assertRevisionOutsideSet('revid1', rev_set)
+
+    def test_not_first_parent(self):
+        self.builder.build_snapshot('revid1', None, [])
+        self.builder.build_snapshot('revid2', None, [])
+        self.builder.build_snapshot('revid3', None, [])
+        rev_set = ['revid3', 'revid2']
+        self.assertRevisionOutsideSet('revid1', rev_set)
+
+    def test_not_null(self):
+        rev_set = ['initial']
+        self.assertRevisionOutsideSet(_mod_revision.NULL_REVISION, rev_set)
+
+    def test_not_null_set(self):
+        self.builder.build_snapshot('revid1', None, [])
+        rev_set = [_mod_revision.NULL_REVISION]
+        self.assertRevisionOutsideSet(_mod_revision.NULL_REVISION, rev_set)
+
+    def test_ghost(self):
+        self.builder.build_snapshot('revid1', None, [])
+        rev_set = ['ghost', 'revid1']
+        self.assertRevisionOutsideSet('initial', rev_set)
+
+    def test_ghost_parent(self):
+        self.builder.build_snapshot('revid1', None, [])
+        self.builder.build_snapshot('revid2', ['revid1', 'ghost'], [])
+        rev_set = ['revid2', 'revid1']
+        self.assertRevisionOutsideSet('initial', rev_set)
+
+    def test_righthand_parent(self):
+        self.builder.build_snapshot('revid1', None, [])
+        self.builder.build_snapshot('revid2a', ['revid1'], [])
+        self.builder.build_snapshot('revid2b', ['revid1'], [])
+        self.builder.build_snapshot('revid3', ['revid2a', 'revid2b'], [])
+        rev_set = ['revid3', 'revid2a']
+        self.assertRevisionOutsideSet('revid2b', rev_set)
+
+
 class TestWithBrokenRepo(TestCaseWithTransport):
     """These tests seem to be more appropriate as interface tests?"""
 
@@ -1050,13 +1131,15 @@
         pack_transport = self.get_transport('pack')
         index_transport = self.get_transport('index')
         upload_transport.mkdir('.')
-        collection = pack_repo.RepositoryPackCollection(repo=None,
+        collection = pack_repo.RepositoryPackCollection(
+            repo=None,
             transport=self.get_transport('.'),
             index_transport=index_transport,
             upload_transport=upload_transport,
             pack_transport=pack_transport,
             index_builder_class=BTreeBuilder,
-            index_class=BTreeGraphIndex)
+            index_class=BTreeGraphIndex,
+            use_chk_index=False)
         pack = pack_repo.NewPack(collection)
         self.assertIsInstance(pack.revision_index, BTreeBuilder)
         self.assertIsInstance(pack.inventory_index, BTreeBuilder)
@@ -1121,3 +1204,19 @@
         self.assertTrue(new_pack.inventory_index._optimize_for_size)
         self.assertTrue(new_pack.text_index._optimize_for_size)
         self.assertTrue(new_pack.signature_index._optimize_for_size)
+
+
+class TestGCCHKPackCollection(TestCaseWithTransport):
+
+    def test_stream_source_to_gc(self):
+        source = self.make_repository('source', format='development6-rich-root')
+        target = self.make_repository('target', format='development6-rich-root')
+        stream = source._get_source(target._format)
+        self.assertIsInstance(stream, groupcompress_repo.GroupCHKStreamSource)
+
+    def test_stream_source_to_non_gc(self):
+        source = self.make_repository('source', format='development6-rich-root')
+        target = self.make_repository('target', format='rich-root-pack')
+        stream = source._get_source(target._format)
+        # We don't want the child GroupCHKStreamSource
+        self.assertIs(type(stream), repository.StreamSource)

=== modified file 'doc/developers/development-repo.txt'
--- doc/developers/development-repo.txt	2009-04-03 01:34:58 +0000
+++ doc/developers/development-repo.txt	2009-04-07 12:46:10 +0000
@@ -244,24 +244,33 @@
 development
 -----------
 
-Currently an alias for Development2
+Not currently available, as our development formats are all rich root or
+subtrees now.
+
+development-rich-root
+---------------------
+
+Currently an alias for Development6Subtree
 
 development-subtree
 -------------------
 
-Currently an alias for Development2Subtree
-
-Development2[Subtree]
----------------------
-
-These formats use B+Tree indices which are considerably faster than
-the earlier indices in bzr.
-
-Development5[Subtree]
----------------------
-
-These formats use B+Tree indices and also offer a CHK based byte store
-in addition to the revision/inventory/signatures and text stores.
+Currently an alias for Development6Subtree
+
+Development6RichRoot[Subtree]
+-----------------------------
+
+These formats use the new groupcompress delta compress and a CHK(Content
+Hash Key) based inventory store which is much faster at incremental
+operations than the prior XML based store.
+*Note* Converting from a non-rich-root to a rich-root format is a
+one-way upgrade, and you cannot merge back afterwards: using this format
+for everyday use is likely to cause all developers of a project to
+upgrade to a rich-root format themselves. This is fine, as bzr is moving
+to make rich-root formats the default and to get all users to upgrade,
+but we have not finalised the migration process, and until we do do not
+recomment that casual users upgrade. Users of bzr-svn are already using
+rich-root formats and can test with this with impunity.
 
 
 ..

